@echo off
REM
REM BEGIN COPYRIGHT
REM *************************************************************************
REM Licensed Materials - Property of IBM 
REM 5724-L01, 5655-N53, 5724-I82, 5655-R15
REM (C) Copyright IBM Corporation 2012. All rights reserved. 
REM US Government Users Restricted Rights - Use, duplication, or disclosure
REM restricted by GSA ADP Schedule Contract with IBM Corp.
REM *************************************************************************
REM END COPYRIGHT
REM
REM --------------------------------------------------------------------------
REM Description:   This batch file creates Performance DW database for SQL Server
REM
REM The SQL Server JDBC driver supports both mixed authentication mode and
REM Windows authentication mode. 
REM
REM This file for use on Windows systems
REM Run the script always where it is located rather running from different folder
REM
REM Usage: 
REM  	configPerformanceDWDB.bat
REM
REM Example:
REM 	configPerformanceDWDB.bat             // use an existing database
REM     
REM Note:
REM		Enter user name and password to get database connection first.
REM 	Run this script from its folder instead of a different folder.
REM       
REM Return Codes:  
REM		0 for success
REM --------------------------------------------------------------------------

setlocal

SET CUR_DIR=%cd%

%~d0
cd %~p0

set RC=0

REM The name of the performanceDW database. 
set DB_NAME=@DB_NAME@
set SERVER=@DB_HOSTNAME@
set DB_PASS=
set DB_USER=@DB_USER@
set DB_WINAUTH=

REM :SERVER
set SERVER_PARAM=-S %SERVER%
if "%SERVER%"=="" set SERVER_PARAM=
if "%SERVER%"=="@DB_HOSTNAME@" set SERVER_PARAM=

:START

:INPUT_USERNAME
if "%DB_WINAUTH%"==""  (
	set /p DB_WINAUTH=Use Windows Authentication? [y/n]: 
	  goto INPUT_USERNAME
)
if  "%DB_WINAUTH%"=="Y" (
	goto SET_CONNECTION_ID
) else (
	if "%DB_WINAUTH%"=="y" (
		goto SET_CONNECTION_ID
	) else (
		if "%DB_USER%"==""  (
		  set /p DB_USER=Please enter username: 
		  goto INPUT_USERNAME
		)
		if "%DB_PASSWORD%"==""  (
		  set /p DB_PASSWORD=Please enter password: 
		  goto INPUT_USERNAME
		)	
	)
)


:SET_CONNECTION_ID
if  "%DB_WINAUTH%"=="y" (
	set  CONNECTION_ID=-E 
) else (
	if  "%DB_WINAUTH%"=="Y" (
		set  CONNECTION_ID=-E 
	) else (
		set  CONNECTION_ID=-U %DB_USER% -P %DB_PASSWORD%
	)
)


:CREATETABLE

dir /B | findstr "createTable_PerformanceDW.sql" > files.log

for /F "tokens=1* delims=" %%v in ( files.log ) do (
	osql -b -d %DB_NAME% %SERVER_PARAM% %CONNECTION_ID% -i%%v
	if %ERRORLEVEL% NEQ 0 set RC=%ERRORLEVEL%&goto PRINT_USAGE
)

goto END

:PRINT_USAGE
REM Print usage messages
echo.
echo ================================================================
echo Usage: configPerformanceDWDB.bat
echo.
echo Note:
echo    Make sure Database Environment set before executing the script
echo ================================================================
goto END

:END
rem del files.log
rem exit %RC%
cd /d "%CUR_DIR%"
endlocal
