-- BEGIN COPYRIGHT
-- *************************************************************************
-- Licensed Materials - Property of IBM 
-- 5724-L01, 5655-N53, 5724-I82, 5655-R15
-- (C) Copyright IBM Corporation 2010. All rights reserved. 
-- US Government Users Restricted Rights - Use, duplication, or disclosure
-- restricted by GSA ADP Schedule Contract with IBM Corp.
-- *************************************************************************
-- END COPYRIGHT
--






@README@
-- This string was intentionally added to the the SQL file
-- as this script can not be executed directly.  The
-- Database Design Tool should be used to generated versions
-- of this script which can be executed successfully.  See
-- the Information Center for more information on using the
-- Database Design Tool
@README@









/*
 * MSSQL Upgrade Script for TeamWorks
 * From Version: Thunderdome
 * To Version: Teamworks 7.0 SP1
 */

    


		
/* START of phase UpgradeInitialDataToTeamworks7sp1 */
    
									
      						INSERT INTO LSW_LOCK("LOCK_ID", "DESCRIPTION") VALUES('DEPLOYMENT_PKG_LOCK_KEY', 'Lock required for add a deployment package to lsw_deployment_package ')      
						
GO

						
      						update LSW_TIME_SCHEDULE set EXCLUDE_HOLIDAY='T' where SCHEDULE_ID in (1 , 3 , 4)      
						
GO


							INSERT INTO LSW_USR("USER_ID", "USER_NAME", "PASSWD", "FULL_NAME", "IS_DISABLED", "LAST_LOGIN_DATETIME", "OLD_PASSWORDS") 
								VALUES(7, 'tw_runtime_server', 'bx0QhdSSiBX5c', 'Internal Runtime user', 'F', '', 'bx0QhdSSiBX5c')							      						      
						
GO


							INSERT INTO LSW_USR_XREF("USER_ID", "USER_NAME") VALUES(7, 'tw_runtime_server')							      						      
						
GO


		
/* END of phase UpgradeInitialDataToTeamworks7sp1 */

		
/* START of phase UpgradeProcSchemaToTeamworks7SP1 */
    
			DROP TABLE LSW_BLUEPRINT_FOLDER_ATTRS
GO



			
if not exists (select name from sysobjects where name = 'LSW_DEPLOYMENT_PACKAGE')
CREATE  TABLE LSW_DEPLOYMENT_PACKAGE(
SNAPSHOT_ID UNIQUEIDENTIFIER,
SERVER_ID UNIQUEIDENTIFIER NOT NULL,
DEPLOYMENT_PACKAGE IMAGE)
GO


if not exists (select name from sysobjects where name = 'LSWC_DPLPKG_FK1' )
ALTER TABLE LSW_DEPLOYMENT_PACKAGE ADD CONSTRAINT LSWC_DPLPKG_FK1
	FOREIGN KEY(SNAPSHOT_ID)
	REFERENCES LSW_SNAPSHOT(SNAPSHOT_ID)
	
GO


if not exists (select name from sysobjects where name = 'LSWC_DPLPKG_FK2' )
ALTER TABLE LSW_DEPLOYMENT_PACKAGE ADD CONSTRAINT LSWC_DPLPKG_FK2
	FOREIGN KEY(SERVER_ID)
	REFERENCES LSW_SERVER(SERVER_ID)
	
GO


if not exists (select name from sys.indexes where name = 'LSWC_DPLPKG_UQ' )
CREATE UNIQUE INDEX LSWC_DPLPKG_UQ ON LSW_DEPLOYMENT_PACKAGE(SNAPSHOT_ID,SERVER_ID)

GO


if not exists (select name from sysobjects where name = 'LSW_BLUEPRINT_SUBSCRIPTION')
CREATE  TABLE LSW_BLUEPRINT_SUBSCRIPTION(
BLUEPRINT_SUBSCRIPTION_ID UNIQUEIDENTIFIER NOT NULL,
PROCESS_ID NVARCHAR(25) NOT NULL,
BLUEPRINT_ID NVARCHAR(25) NOT NULL,
ROOT_BPD_ID UNIQUEIDENTIFIER NOT NULL,
ACCOUNT NVARCHAR(255),
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL)
GO


if not exists (select name from sysobjects where name = 'LSWC_BPS_PK' )     
ALTER TABLE LSW_BLUEPRINT_SUBSCRIPTION ADD CONSTRAINT LSWC_BPS_PK
    PRIMARY KEY(VERSION_ID ) 
GO


if not exists (select name from sys.indexes where name = 'LSWC_BPS_PK3' )
CREATE INDEX LSWC_BPS_PK3 ON LSW_BLUEPRINT_SUBSCRIPTION(GUID) 
GO


							DROP INDEX LSW_GRP_GRP_MEM_XREF.LSWC_GGXXREF_NU1
                        
GO


if not exists (select name from sys.indexes where name = 'LSWC_GGMXREF_NU1' )
CREATE INDEX LSWC_GGMXREF_NU1 ON LSW_GRP_GRP_MEM_XREF(CONTAINER_GROUP_ID) 
GO


if not exists (select name from sys.indexes where name = 'LSWC_GGXXREF_NU1' )
CREATE INDEX LSWC_GGXXREF_NU1 ON LSW_GRP_GRP_MEM_EXPLODED_XREF(GROUP_ID) 
GO


ALTER TABLE LSW_PROCESS ALTER COLUMN NAME NVARCHAR(255) NULL
GO


		
/* END of phase UpgradeProcSchemaToTeamworks7SP1 */

	
/*
 * MSSQL Upgrade Script for TeamWorks
 * From Version: Teamworks 7.0 SP1
 * To Version: Teamworks 7.1.0
 */

    

		
/* START of phase ProcUpgradeTo710 */
    
			
ALTER TABLE LSW_USR ALTER COLUMN PASSWD NVARCHAR(250) NULL
GO


ALTER TABLE LSW_USR ALTER COLUMN OLD_PASSWORDS NVARCHAR(2000) NULL
GO


							DROP INDEX LSW_IC.LSWC_IC_NUQ3
                 
GO

ALTER TABLE LSW_IC DROP COLUMN NESTED_IC_ID
GO


ALTER TABLE LSW_SERVER ALTER COLUMN PROVIDER_URL NVARCHAR(500) NULL
GO


		
/* END of phase ProcUpgradeTo710 */


		
/* START of phase UpdateTwRuntimeServerPassword */
    
									
      						update LSW_USR set PASSWD='twGsuLIVc07yY' where USER_NAME='tw_runtime_server'      
						
GO


		
/* END of phase UpdateTwRuntimeServerPassword */


	
/*
 * MSSQL Upgrade Script for TeamWorks
 * From Version: Teamworks 7.1.0
 * To Version: Teamworks 7.1.0.1
 */

    

		
/* START of phase ProcUpgradeTo7101 */
    
			
ALTER  TABLE LSW_SERVER 
ADD 
INSTALLER_GROUP_ID DECIMAL(38,0)
GO


if not exists (select name from sysobjects where name = 'LSWC_INSTL_GRP_FK' )
ALTER TABLE LSW_SERVER ADD CONSTRAINT LSWC_INSTL_GRP_FK
	FOREIGN KEY(INSTALLER_GROUP_ID)
	REFERENCES LSW_USR_GRP_XREF(GROUP_ID)
	
GO


		
/* END of phase ProcUpgradeTo7101 */

	
/*
 * MSSQL Upgrade Script for TeamWorks
 * From Version: Teamworks 7.1.0
 * To Version: Teamworks 7.2.0
 */

    

		
/* START of phase ProcUpgradeTo720 */
    
			
ALTER TABLE LSW_PROCESS_VARIABLE ALTER COLUMN NAME NVARCHAR(255) NULL
GO


ALTER TABLE LSW_EXTACT_PARAMETER ALTER COLUMN NAME NVARCHAR(255) NULL
GO


if not exists (select name from sys.indexes where name = 'IDX7_PO_VERSIONS' )
CREATE INDEX IDX7_PO_VERSIONS ON LSW_PO_VERSIONS(BRANCH_ID,PO_VERSION_ID,VERSION_SUMMARY_ID) 
GO


ALTER TABLE LSW_BPD_INSTANCE_VARIABLES ALTER COLUMN VARIABLE_TYPE NVARCHAR(64) NULL
GO


ALTER  TABLE LSW_USR_XREF 
ADD 
FULL_NAME NVARCHAR(255)
GO


							BEGIN TRANSACTION;
							UPDATE LSW_USR_XREF SET FULL_NAME=u.FULL_NAME FROM LSW_USR_XREF x JOIN
							LSW_USR u ON x.USER_NAME=u.USER_NAME;
							UPDATE LSW_USR_XREF SET FULL_NAME=USER_NAME WHERE FULL_NAME IS NULL AND
							NOT EXISTS (SELECT 1 FROM LSW_USR u WHERE
							u.USER_NAME=LSW_USR_XREF.USER_NAME);
							COMMIT TRANSACTION;
						
GO


if not exists (select name from sysobjects where name = 'LSW_CA_TEMPLATE')
CREATE  TABLE LSW_CA_TEMPLATE(
ID DECIMAL(38,0) NOT NULL,
NAME NVARCHAR(128) NOT NULL,
BPD_GUID NVARCHAR(128) NOT NULL)
GO


if not exists (select name from sysobjects where name = 'LSW_CA_TEMPLATE_DATA')
CREATE  TABLE LSW_CA_TEMPLATE_DATA(
ID DECIMAL(38,0) NOT NULL,
CA_GUID NVARCHAR(128) NOT NULL)
GO


if not exists (select name from sysobjects where name = 'LSWC_TEMPLATE_PK' )     
ALTER TABLE LSW_CA_TEMPLATE ADD CONSTRAINT LSWC_TEMPLATE_PK
    PRIMARY KEY(ID ) 
GO


if not exists (select name from sysobjects where name = 'LSWC_TEMPLATE_FK' )
ALTER TABLE LSW_CA_TEMPLATE_DATA ADD CONSTRAINT LSWC_TEMPLATE_FK
	FOREIGN KEY(ID)
	REFERENCES LSW_CA_TEMPLATE(ID)
	
GO


ALTER  TABLE LSW_BPD 
ADD 
IS_CRITICAL_PATH_ENABLED NCHAR(1) DEFAULT 'T' NOT NULL
GO


							ALTER TABLE LSW_RUNTIME_ERROR ALTER COLUMN
							ERROR_MESSAGE NTEXT NULL
						
GO


DROP TABLE LSW_TASK_CUSTOM
GO


ALTER  TABLE LSW_UCA
DROP COLUMN 
LAST_RUN_DATETIME ,
NEXT_RUN_DATETIME 
GO


ALTER  TABLE LSW_COACH 
ADD 
XSL_REF UNIQUEIDENTIFIER
GO


if not exists (select name from sysobjects where name = 'LSW_PROJECT_DEFAULTS')
CREATE  TABLE LSW_PROJECT_DEFAULTS(
PROJECT_DEFAULTS_ID UNIQUEIDENTIFIER NOT NULL,
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL,
DEFAULT_XSL_REF UNIQUEIDENTIFIER,
DEFAULT_CSS_REF UNIQUEIDENTIFIER,
DEFAULT_JS_REFS NVARCHAR(2000))
GO


if not exists (select name from sysobjects where name = 'LSWC_PRJ_DFTS_PK' )     
ALTER TABLE LSW_PROJECT_DEFAULTS ADD CONSTRAINT LSWC_PRJ_DFTS_PK
    PRIMARY KEY(VERSION_ID ) 
GO


if not exists (select name from sys.indexes where name = 'LSWC_PRJ_DFTS_PK3' )
CREATE INDEX LSWC_PRJ_DFTS_PK3 ON LSW_PROJECT_DEFAULTS(GUID) 
GO


if not exists (select name from sysobjects where name = 'LSW_ILOG_CONNECTOR')
CREATE  TABLE LSW_ILOG_CONNECTOR(
ILOG_CONNECTOR_ID UNIQUEIDENTIFIER NOT NULL,
ATTACHED_PROCESS_REF UNIQUEIDENTIFIER,
DEFINITION IMAGE NOT NULL,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
GO


if not exists (select name from sysobjects where name = 'LSWC_ILNTR_PK' )     
ALTER TABLE LSW_ILOG_CONNECTOR ADD CONSTRAINT LSWC_ILNTR_PK
    PRIMARY KEY(VERSION_ID ) 
GO


if not exists (select name from sys.indexes where name = 'LSWC_ILNTR_PK3' )
CREATE INDEX LSWC_ILNTR_PK3 ON LSW_ILOG_CONNECTOR(GUID) 
GO


ALTER  TABLE LSW_EPV_VAR_VALUE
DROP COLUMN 
EPV_VAR_REF 
GO


ALTER  TABLE LSW_ENV_VAR_VAL
DROP COLUMN 
ENV_VAR_REF 
GO


ALTER  TABLE LSW_ENV_VAR_VAL 
ADD 
BRANCH_ID UNIQUEIDENTIFIER,
TIP NCHAR(1) DEFAULT 'F'
GO


ALTER TABLE LSW_DYNAMIC_GROUP_CONSTRAINT ALTER COLUMN VALUE NVARCHAR(1000) NULL
GO


ALTER TABLE LSW_BPD_INSTANCE_VARIABLES ALTER COLUMN STRING_VALUE NVARCHAR(1000) NULL
GO


ALTER TABLE LSW_BPD_DOCUMENTS ALTER COLUMN FILENAME NVARCHAR(1000) NULL
GO


ALTER TABLE LSW_BPD_INSTANCE_DOC_PROPS ALTER COLUMN NAME NVARCHAR(1000) NULL
GO


ALTER TABLE LSW_BPD_INSTANCE_DOC_PROPS ALTER COLUMN VALUE NVARCHAR(1000) NULL
GO


ALTER TABLE LSW_BPD_INSTANCE_DOCUMENTS ALTER COLUMN FILENAME NVARCHAR(1000) NULL
GO


ALTER TABLE LSW_USR_ATTR ALTER COLUMN ATTR_VALUE NVARCHAR(1000) NULL
GO


ALTER TABLE LSW_PARTICIPANT ALTER COLUMN PARTICIPANT_DEFINITION NVARCHAR(1000) NULL
GO


ALTER TABLE LSW_EM_TASK ALTER COLUMN TASK_ARGUMENTS_STR NVARCHAR(1000) NULL
GO


ALTER TABLE LSW_REPORT_DS_LAYOUT_LINK ALTER COLUMN DEFAULT_VALUE NVARCHAR(1000) NULL
GO


ALTER TABLE LSW_REPORT_VARIABLES ALTER COLUMN VALUE NVARCHAR(1000) NULL
GO


ALTER TABLE LSW_BREAKPOINT ALTER COLUMN CONDITION NVARCHAR(1000) NULL
GO


ALTER TABLE LSW_LAUNCHER ALTER COLUMN CMD NVARCHAR(1000) NULL
GO


ALTER TABLE LSW_IC_OUTPUT_PROPERTY ALTER COLUMN NAME NVARCHAR(1000) NULL
GO


ALTER TABLE LSW_IC_OUTPUT_PROPERTY ALTER COLUMN KEY_VAL NVARCHAR(1000) NULL
GO


ALTER TABLE LSW_UCA_PARM ALTER COLUMN PARM_VALUE NVARCHAR(1000) NULL
GO


ALTER TABLE LSW_IC_INPUT_PROPERTY ALTER COLUMN KEY_VAL NVARCHAR(1000) NULL
GO


ALTER TABLE LSW_IC_INPUT_PROPERTY ALTER COLUMN NAME NVARCHAR(1000) NULL
GO


ALTER TABLE LSW_SWITCH_CONDITION ALTER COLUMN CONDITION NVARCHAR(1000) NULL
GO


ALTER TABLE LSW_FAVORITE ALTER COLUMN NAME NVARCHAR(1000) NULL
GO


							ALTER TABLE LSW_EM_TASK_HISTORY ALTER COLUMN
							ERROR_MESSAGE NTEXT NULL
						
GO


							ALTER TABLE LSW_PROCESS_ITEM ALTER COLUMN
							TRACE_MESSAGE NTEXT NULL
						
GO


							ALTER TABLE LSW_USR ALTER COLUMN OLD_PASSWORDS NTEXT
							NULL
						
GO


							DROP INDEX LSW_PROJECT.IDX_SHORT_NAME
                        
GO


if not exists (select name from sys.indexes where name = 'IDX_SHORT_NAME' )
CREATE INDEX IDX_SHORT_NAME ON LSW_PROJECT(SHORT_NAME) 
GO


if not exists (select name from sysobjects where name = 'LSW_ENV_VAR_TYPE')
CREATE  TABLE LSW_ENV_VAR_TYPE(
ENV_VAR_TYPE_ID DECIMAL(2, 0) NOT NULL,
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT)
GO


if not exists (select name from sysobjects where name = 'LSWC_ENV_VART_PK' )     
ALTER TABLE LSW_ENV_VAR_TYPE ADD CONSTRAINT LSWC_ENV_VART_PK
    PRIMARY KEY(ENV_VAR_TYPE_ID ) 
GO


ALTER  TABLE LSW_ENV_VAR 
ADD 
ENV_VAR_TYPE_ID DECIMAL(2, 0) DEFAULT 0 NOT NULL
GO


GO


if not exists (select name from sysobjects where name = 'LSW_REPORT_RBG_LINK')
CREATE  TABLE LSW_REPORT_RBG_LINK(
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
GUID NVARCHAR(128) NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL,
RBG_REF UNIQUEIDENTIFIER NOT NULL,
REPORT_ID UNIQUEIDENTIFIER NOT NULL,
REPORT_RBG_LINK_ID UNIQUEIDENTIFIER NOT NULL)
GO


if not exists (select name from sysobjects where name = 'LSWC_REP_RBG_PK' )     
ALTER TABLE LSW_REPORT_RBG_LINK ADD CONSTRAINT LSWC_REP_RBG_PK
    PRIMARY KEY(VERSION_ID ) 
GO


if not exists (select name from sys.indexes where name = 'LSWC_REP_RBG_PK3' )
CREATE INDEX LSWC_REP_RBG_PK3 ON LSW_REPORT_RBG_LINK(GUID) 
GO


		
/* END of phase ProcUpgradeTo720 */


		
/* START of phase UpgradeInitialDataToTeamworks720 */
    
			
							BEGIN TRANSACTION;
							INSERT INTO LSW_USR_GRP_XREF
							(GROUP_ID,GROUP_NAME,DISPLAY_NAME,PARENT_GROUP_ID,GROUP_TYPE,DESCRIPTION)
							VALUES(16, 'tw_allusers_temp', 'tw_allusers', null, 3, 'Group for
							all people.');
							UPDATE LSW_USR_GRP_XREF SET PARENT_GROUP_ID = 16 WHERE PARENT_GROUP_ID
							= 14;

							UPDATE LSW_FAVORITE SET GROUP_ID = 16 WHERE GROUP_ID = 14;
							UPDATE LSW_PARTICIPANT_GROUP SET GROUP_ID = 16 WHERE GROUP_ID = 14;
							UPDATE LSW_USR_GRP_MEM_XREF SET GROUP_ID = 16 WHERE GROUP_ID =
							14;

							UPDATE LSW_GRP_GRP_MEM_XREF SET GROUP_ID = 16 WHERE GROUP_ID = 14;
							UPDATE LSW_GRP_GRP_MEM_XREF SET CONTAINER_GROUP_ID = 16 WHERE
							CONTAINER_GROUP_ID = 14;

							UPDATE LSW_GRP_GRP_MEM_EXPLODED_XREF SET GROUP_ID = 16 WHERE GROUP_ID =
							14;
							UPDATE LSW_GRP_GRP_MEM_EXPLODED_XREF SET CONTAINER_GROUP_ID = 16 WHERE
							CONTAINER_GROUP_ID = 14;
							UPDATE LSW_GRP_GRP_MEM_EXPLODED_XREF SET MEM_PATH = REPLACE(MEM_PATH,
							'#14#', '#16#');

							DELETE FROM LSW_USR_GRP_XREF WHERE GROUP_ID = 14;
							UPDATE LSW_USR_GRP_XREF SET GROUP_NAME = 'tw_allusers' WHERE GROUP_NAME
							= 'tw_allusers_temp';

							UPDATE LSW_TASK SET GROUP_ID = 16 WHERE GROUP_ID = 14;
							UPDATE LSW_TASK SET GROUP_ID = -16 WHERE GROUP_ID = -14;
							COMMIT
							TRANSACTION;
						
GO


							BEGIN TRANSACTION;
							INSERT INTO LSW_ENV_VAR_TYPE (ENV_VAR_TYPE_ID,NAME,DESCRIPTION)
							VALUES(0, 0, 'General');
							INSERT INTO LSW_ENV_VAR_TYPE (ENV_VAR_TYPE_ID,NAME,DESCRIPTION)
							VALUES(1, 1, 'ILOG Rules Server');
							INSERT INTO LSW_ENV_VAR_TYPE (ENV_VAR_TYPE_ID,NAME,DESCRIPTION)
							VALUES(2, 2, 'ICI Web Service URL');
							INSERT INTO LSW_ENV_VAR_TYPE (ENV_VAR_TYPE_ID,NAME,DESCRIPTION)
							VALUES(3, 3, 'ICI Connector Name');
							COMMIT TRANSACTION;
						
GO


							BEGIN TRANSACTION;
							UPDATE LSW_SAVED_SEARCHES SET SEARCH_NAME='portal.savedsearch.inbox'
							WHERE SEARCH_ID=1;
							UPDATE LSW_SAVED_SEARCHES SET SEARCH_NAME='portal.savedsearch.history'
							WHERE SEARCH_ID=2;
							UPDATE LSW_SAVED_SEARCHES SET
							SEARCH_NAME='portal.savedsearch.help_reqs' WHERE SEARCH_ID=3;
							UPDATE LSW_SAVED_SEARCHES SET
							SEARCH_NAME='portal.savedsearch.alerts' WHERE SEARCH_ID=4;
							COMMIT
							TRANSACTION;							
						
GO


ALTER TABLE LSW_BPD_INSTANCE_VARIABLES ALTER COLUMN STRING_VALUE NVARCHAR(512) NULL
GO


							BEGIN TRANSACTION;
							INSERT INTO LSW_USR_GRP_XREF(GROUP_ID, GROUP_NAME, DISPLAY_NAME,
							PARENT_GROUP_ID, GROUP_TYPE, DESCRIPTION)
							VALUES(15, 'tw_process_owners', 'tw_process_owners', null, 3, 'Group for
							people with full access to critical path');
							INSERT INTO LSW_USR_GRP_MEM_XREF(USER_ID, GROUP_ID) VALUES(1, 15);
							COMMIT TRANSACTION;
						
GO


		
/* END of phase UpgradeInitialDataToTeamworks720 */


		
/* START of phase UpgradeProjectOwnerToTeamworks720 */
    
			
							BEGIN TRANSACTION;
							UPDATE LSW_ACL_ENTRY SET USER_ID=2 WHERE USER_ID=1 AND PO_TYPE=2066 AND
							PO_ID='23d3ecec-6fdb-4033-9c57-e931aa13761f' AND MASK=127;
							UPDATE LSW_ACL_ENTRY SET USER_ID=2 WHERE USER_ID=1 AND PO_TYPE=2066 AND
							PO_ID='14519785-cbb2-466e-a744-99c47aff98c5' AND MASK=127;
							COMMIT
							TRANSACTION;							
						
GO


		
/* END of phase UpgradeProjectOwnerToTeamworks720 */

	
/*
 * MSSQL Upgrade Script for TeamWorks
 * From Version: Teamworks 7.2.0
 * To Version: Teamworks 7.5.0
 */

    

		
/* START of phase ProcUpgradeTo750 */
    
			
ALTER  TABLE LSW_JAVA_CONNECTOR
DROP COLUMN 
ATTACHED_PROCESS_REF 
GO


ALTER  TABLE LSW_WS_CONNECTOR
DROP COLUMN 
ATTACHED_PROCESS_REF 
GO


ALTER  TABLE LSW_ILOG_CONNECTOR
DROP COLUMN 
ATTACHED_PROCESS_REF 
GO


if not exists (select name from sysobjects where name = 'LSW_SCA_CONNECTOR')
CREATE  TABLE LSW_SCA_CONNECTOR(
SCA_CONNECTOR_ID UNIQUEIDENTIFIER NOT NULL,
MODULE_NAME NVARCHAR(256),
EXPORT_NAME NVARCHAR(256),
MODULE_VERSION NVARCHAR(32),
OPERATION_NAME NVARCHAR(256),
IS_ASYNC_INVOCATION NCHAR(1),
OPERATION_STYLE DECIMAL(1, 0),
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
GO


if not exists (select name from sysobjects where name = 'LSWC_SCNTR_PK' )     
ALTER TABLE LSW_SCA_CONNECTOR ADD CONSTRAINT LSWC_SCNTR_PK
    PRIMARY KEY(VERSION_ID ) 
GO


if not exists (select name from sys.indexes where name = 'LSWC_SCNTR_PK3' )
CREATE INDEX LSWC_SCNTR_PK3 ON LSW_SCA_CONNECTOR(GUID) 
GO


ALTER  TABLE LSW_PROJECT_DEFAULTS 
ADD 
NAMESPACE NVARCHAR(256),
IS_WBM_ENABLED NCHAR(1) DEFAULT 'F',
IS_IID_OPTIMIZED NCHAR(1) DEFAULT 'F'
GO


if not exists (select name from sysobjects where name = 'BPM_CONTRIBUTION')
CREATE  TABLE BPM_CONTRIBUTION(
CONTRIBUTION_ID UNIQUEIDENTIFIER NOT NULL,
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
CREATED_BY_USER_ID DECIMAL(38,0) NOT NULL,
CREATED_ON DATETIME NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL,
FILENAME NVARCHAR(1024) DEFAULT ' ' NOT NULL)
GO


if not exists (select name from sysobjects where name = 'BPM_NODE_PK' )     
ALTER TABLE BPM_CONTRIBUTION ADD CONSTRAINT BPM_NODE_PK
    PRIMARY KEY(VERSION_ID ) 
GO


if not exists (select name from sys.indexes where name = 'BPM_NODE_PK3' )
CREATE INDEX BPM_NODE_PK3 ON BPM_CONTRIBUTION(GUID) 
GO


if not exists (select name from sys.indexes where name = 'BPM_IDX_NODE' )
CREATE INDEX BPM_IDX_NODE ON BPM_CONTRIBUTION(CONTRIBUTION_ID) 
GO


if not exists (select name from sys.indexes where name = 'BPM_IDX2_NODE' )
CREATE INDEX BPM_IDX2_NODE ON BPM_CONTRIBUTION(NAME) 
GO


if not exists (select name from sysobjects where name = 'BPM_CTRB_PROPERTY')
CREATE  TABLE BPM_CTRB_PROPERTY(
PROPERTY_ID UNIQUEIDENTIFIER NOT NULL,
CONTRIBUTION_ID UNIQUEIDENTIFIER NOT NULL,
PROP_VALUE NVARCHAR(1000),
PROP_TYPE_CODE DECIMAL(8, 0) NOT NULL,
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
GO


if not exists (select name from sysobjects where name = 'BPM_CPRP_PK' )     
ALTER TABLE BPM_CTRB_PROPERTY ADD CONSTRAINT BPM_CPRP_PK
    PRIMARY KEY(VERSION_ID ) 
GO


if not exists (select name from sys.indexes where name = 'BPM_CPRP_PK3' )
CREATE INDEX BPM_CPRP_PK3 ON BPM_CTRB_PROPERTY(GUID) 
GO


if not exists (select name from sys.indexes where name = 'BPM_CPRP_NUQ' )
CREATE INDEX BPM_CPRP_NUQ ON BPM_CTRB_PROPERTY(CONTRIBUTION_ID,VERSION_ID) 
GO


if not exists (select name from sys.indexes where name = 'BPM_IDX_CPRP' )
CREATE INDEX BPM_IDX_CPRP ON BPM_CTRB_PROPERTY(NAME) 
GO


if not exists (select name from sysobjects where name = 'BPM_CTRB_DEPENDENCY')
CREATE  TABLE BPM_CTRB_DEPENDENCY(
CTRB_DEPENDENCY_ID UNIQUEIDENTIFIER NOT NULL,
LIBRARY_NAME NVARCHAR(1024) NOT NULL,
CONTRIBUTION_ID UNIQUEIDENTIFIER NOT NULL,
CONTRIBUTION_REF UNIQUEIDENTIFIER,
DEPLOY_WITH NCHAR(1) DEFAULT 'T' NOT NULL,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
GO


if not exists (select name from sysobjects where name = 'BPM_CDEP_PK' )     
ALTER TABLE BPM_CTRB_DEPENDENCY ADD CONSTRAINT BPM_CDEP_PK
    PRIMARY KEY(VERSION_ID ) 
GO


if not exists (select name from sys.indexes where name = 'BPM_CDEP_PK3' )
CREATE INDEX BPM_CDEP_PK3 ON BPM_CTRB_DEPENDENCY(GUID) 
GO


if not exists (select name from sys.indexes where name = 'BPM_CDEP_NUQ' )
CREATE INDEX BPM_CDEP_NUQ ON BPM_CTRB_DEPENDENCY(CONTRIBUTION_ID,VERSION_ID) 
GO


if not exists (select name from sysobjects where name = 'BPM_ARTIFACT')
CREATE  TABLE BPM_ARTIFACT(
ARTIFACT_ID UNIQUEIDENTIFIER NOT NULL,
ART_DATA_UUID UNIQUEIDENTIFIER,
CONTRIBUTION_ID UNIQUEIDENTIFIER NOT NULL,
MEDIA_TYPE NVARCHAR(100) DEFAULT 'application/octet-stream',
CHAR_ENCODING NVARCHAR(100) DEFAULT 'UTF-8',
LENGTH DECIMAL(38,0),
FULL_PATH NVARCHAR(1024) NOT NULL,
DIGEST NVARCHAR(45) NOT NULL,
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
CREATED_BY_USER_ID DECIMAL(38,0) NOT NULL,
CREATED_ON DATETIME NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
GO


if not exists (select name from sysobjects where name = 'BPM_NPRP_PK' )     
ALTER TABLE BPM_ARTIFACT ADD CONSTRAINT BPM_NPRP_PK
    PRIMARY KEY(VERSION_ID ) 
GO


if not exists (select name from sys.indexes where name = 'BPM_NPRP_PK3' )
CREATE INDEX BPM_NPRP_PK3 ON BPM_ARTIFACT(GUID) 
GO


if not exists (select name from sys.indexes where name = 'BPM_IDX_ART' )
CREATE INDEX BPM_IDX_ART ON BPM_ARTIFACT(ARTIFACT_ID) 
GO


if not exists (select name from sys.indexes where name = 'BPM_IDX2_ART' )
CREATE INDEX BPM_IDX2_ART ON BPM_ARTIFACT(NAME) 
GO


if not exists (select name from sys.indexes where name = 'BPM_IDX3_ART' )
CREATE INDEX BPM_IDX3_ART ON BPM_ARTIFACT(FULL_PATH) 
GO


if not exists (select name from sysobjects where name = 'BPM_ARTIFACT_DATA')
CREATE  TABLE BPM_ARTIFACT_DATA(
ART_DATA_ID UNIQUEIDENTIFIER NOT NULL,
ART_DATA IMAGE)
GO


if not exists (select name from sysobjects where name = 'BPM_ART_DATA_PK' )     
ALTER TABLE BPM_ARTIFACT_DATA ADD CONSTRAINT BPM_ART_DATA_PK
    PRIMARY KEY(ART_DATA_ID ) 
GO


if not exists (select name from sysobjects where name = 'BPM_PROC_ARTIFACT_REF')
CREATE  TABLE BPM_PROC_ARTIFACT_REF(
PROC_ARTIFACT_REF_ID UNIQUEIDENTIFIER NOT NULL,
PROCESS_ID UNIQUEIDENTIFIER NOT NULL,
ARTIFACT_REF UNIQUEIDENTIFIER NOT NULL,
ARTIFACT_ID UNIQUEIDENTIFIER NOT NULL,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
GO


if not exists (select name from sysobjects where name = 'BPM_PAREF_PK' )     
ALTER TABLE BPM_PROC_ARTIFACT_REF ADD CONSTRAINT BPM_PAREF_PK
    PRIMARY KEY(VERSION_ID ) 
GO


if not exists (select name from sys.indexes where name = 'BPM_PAREF_PK3' )
CREATE INDEX BPM_PAREF_PK3 ON BPM_PROC_ARTIFACT_REF(GUID) 
GO


if not exists (select name from sys.indexes where name = 'BPM_PAREF_NUQ' )
CREATE INDEX BPM_PAREF_NUQ ON BPM_PROC_ARTIFACT_REF(PROCESS_ID,ARTIFACT_ID,VERSION_ID) 
GO


ALTER  TABLE LSW_SNAPSHOT 
ADD 
IS_STARTED NCHAR(1) DEFAULT 'F' NOT NULL,
IS_BLA_ACTIVE NCHAR(1) DEFAULT 'F' NOT NULL,
IS_BLA_INSTALLED NCHAR(1) DEFAULT 'F' NOT NULL,
IS_TIP_DEPLOYED NCHAR(1) DEFAULT 'F' NOT NULL,
ACRONYM NVARCHAR(64)
GO


if not exists (select name from sysobjects where name = 'BPM_CLS_ARTIFACT_REF')
CREATE  TABLE BPM_CLS_ARTIFACT_REF(
CLS_ARTIFACT_REF_ID UNIQUEIDENTIFIER NOT NULL,
CLASS_ID UNIQUEIDENTIFIER NOT NULL,
ARTIFACT_REF UNIQUEIDENTIFIER NOT NULL,
ARTIFACT_ID UNIQUEIDENTIFIER NOT NULL,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
GO


if not exists (select name from sysobjects where name = 'BPM_CAREF_PK' )     
ALTER TABLE BPM_CLS_ARTIFACT_REF ADD CONSTRAINT BPM_CAREF_PK
    PRIMARY KEY(VERSION_ID ) 
GO


if not exists (select name from sys.indexes where name = 'BPM_CAREF_PK3' )
CREATE INDEX BPM_CAREF_PK3 ON BPM_CLS_ARTIFACT_REF(GUID) 
GO


if not exists (select name from sys.indexes where name = 'BPM_CAREF_NUQ' )
CREATE INDEX BPM_CAREF_NUQ ON BPM_CLS_ARTIFACT_REF(CLASS_ID,ARTIFACT_ID,VERSION_ID) 
GO


if not exists (select name from sysobjects where name = 'BPM_BPD_ARTIFACT_REF')
CREATE  TABLE BPM_BPD_ARTIFACT_REF(
BPD_ARTIFACT_REF_ID UNIQUEIDENTIFIER NOT NULL,
BPD_ID UNIQUEIDENTIFIER NOT NULL,
ARTIFACT_REF UNIQUEIDENTIFIER NOT NULL,
ARTIFACT_ID UNIQUEIDENTIFIER NOT NULL,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
GO


if not exists (select name from sysobjects where name = 'BPM_BAREF_PK' )     
ALTER TABLE BPM_BPD_ARTIFACT_REF ADD CONSTRAINT BPM_BAREF_PK
    PRIMARY KEY(VERSION_ID ) 
GO


if not exists (select name from sys.indexes where name = 'BPM_BAREF_PK3' )
CREATE INDEX BPM_BAREF_PK3 ON BPM_BPD_ARTIFACT_REF(GUID) 
GO


if not exists (select name from sys.indexes where name = 'BPM_BAREF_NUQ' )
CREATE INDEX BPM_BAREF_NUQ ON BPM_BPD_ARTIFACT_REF(BPD_ID,ARTIFACT_ID,VERSION_ID) 
GO


if not exists (select name from sysobjects where name = 'BPM_MON_MODEL_DATA')
CREATE  TABLE BPM_MON_MODEL_DATA(
MM_ID UNIQUEIDENTIFIER NOT NULL,
NAME NVARCHAR(128) NOT NULL,
DATA IMAGE)
GO


if not exists (select name from sysobjects where name = 'BPM_MMDATA_PK' )     
ALTER TABLE BPM_MON_MODEL_DATA ADD CONSTRAINT BPM_MMDATA_PK
    PRIMARY KEY(MM_ID ) 
GO


if not exists (select name from sys.indexes where name = 'BPM_MMDATA_UQ' )
CREATE UNIQUE INDEX BPM_MMDATA_UQ ON BPM_MON_MODEL_DATA(NAME)

GO


if not exists (select name from sysobjects where name = 'LSW_SERVER_CAPABILITY')
CREATE  TABLE LSW_SERVER_CAPABILITY(
SERVER_CAPABILITY_ID UNIQUEIDENTIFIER NOT NULL,
SERVER_ID UNIQUEIDENTIFIER NOT NULL,
CAPABILITY_TYPE NVARCHAR(64) NOT NULL,
CAPABILITY_VERSION NVARCHAR(64) NOT NULL)
GO


if not exists (select name from sysobjects where name = 'LSW_CAPABILITY_TYPE')
CREATE  TABLE LSW_CAPABILITY_TYPE(
CAPABILITY_TYPE_ID DECIMAL(2, 0) NOT NULL,
CAPABILITY_CONFIG_ID NVARCHAR(64) NOT NULL,
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT,
IS_OPTIONAL NCHAR(1) DEFAULT '0')
GO


if not exists (select name from sysobjects where name = 'LSWC_SVRCAP_PK' )     
ALTER TABLE LSW_SERVER_CAPABILITY ADD CONSTRAINT LSWC_SVRCAP_PK
    PRIMARY KEY(SERVER_CAPABILITY_ID ) 
GO


if not exists (select name from sysobjects where name = 'LSWC_CAP_TYPE_PK' )     
ALTER TABLE LSW_CAPABILITY_TYPE ADD CONSTRAINT LSWC_CAP_TYPE_PK
    PRIMARY KEY(CAPABILITY_TYPE_ID ) 
GO


if not exists (select name from sysobjects where name = 'LSWC_SVRCAP_FK1' )
ALTER TABLE LSW_SERVER_CAPABILITY ADD CONSTRAINT LSWC_SVRCAP_FK1
	FOREIGN KEY(SERVER_ID)
	REFERENCES LSW_SERVER(SERVER_ID)
	
GO


if not exists (select name from sys.indexes where name = 'IDX_CAPCFG_ID' )
CREATE INDEX IDX_CAPCFG_ID ON LSW_CAPABILITY_TYPE(CAPABILITY_CONFIG_ID) 
GO


if not exists (select name from sys.indexes where name = 'IDX8_LSW_TASK' )
CREATE INDEX IDX8_LSW_TASK ON LSW_TASK(BPD_INSTANCE_ID,STATUS,PRIORITY_ID,GROUP_ID,USER_ID) 
GO


ALTER  TABLE LSW_BRANCH 
ADD 
ACRONYM NVARCHAR(64)
GO


							BEGIN TRANSACTION;
							INSERT INTO LSW_SAVED_SEARCHES (SEARCH_ID, SEARCH_NAME, QUERY) SELECT
							(MAX(SEARCH_ID)+1),'IBM.DEFAULTALLTASKSLIST_75', '<?xml version="1.0" encoding="UTF-8"?><query organization="byTask" first-sort="" second-sort=""> <constraints /> <results> <column name="taskSubject" column-type="task"/> <column name="taskNarrative" column-type="task"/> <column name="taskDueDate" column-type="task"/> <column name="taskReceivedDate" column-type="task"/> <column name="taskPriority" column-type="task"/> <column name="taskStatus" column-type="task"/> <column name="taskReceivedFrom" column-type="task"/> <column name="assignedToUser" column-type="task"/> <column name="taskActivityName" column-type="task"/> <column name="taskId" column-type="task"/> <column name="instanceId" column-type="instance"/> <column name="instanceName" column-type="instance"/> <column name="bpdId" column-type="instance"/> <column name="instanceProcessApp" column-type="instance"/> <column name="instanceSnapshot" column-type="instance"/> <column name="instanceSnapshotId" column-type="instance"/> </results> </query>'
							FROM LSW_SAVED_SEARCHES;
							INSERT INTO LSW_SAVED_SEARCHES (SEARCH_ID, SEARCH_NAME, QUERY) SELECT
							(MAX(SEARCH_ID)+1),'IBM.DEFAULTALLPROCESSLIST_75', '<?xml version="1.0" encoding="UTF-8"?><query organization="byInstance" first-sort="" second-sort=""> <constraints /> <results> <column name="instanceName" column-type="instance"/> <column name="instanceStatus" column-type="instance"/> <column name="bpdName" column-type="instance"/> <column name="instanceId" column-type="instance"/> <column name="bpdId" column-type="instance"/> <column name="instanceProcessApp" column-type="instance"/> <column name="instanceSnapshot" column-type="instance"/> <column name="instanceSnapshotId" column-type="instance"/> </results> </query>'
							FROM LSW_SAVED_SEARCHES;
							COMMIT TRANSACTION;
						
GO


if not exists (select name from sysobjects where name = 'LSW_ILOG_DECISION')
CREATE  TABLE LSW_ILOG_DECISION(
ILOG_DECISION_ID UNIQUEIDENTIFIER NOT NULL,
DEFINITION IMAGE NOT NULL,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
GO


if not exists (select name from sysobjects where name = 'LSWC_ILDT_PK' )     
ALTER TABLE LSW_ILOG_DECISION ADD CONSTRAINT LSWC_ILDT_PK
    PRIMARY KEY(VERSION_ID ) 
GO


if not exists (select name from sys.indexes where name = 'LSWC_ILDT_PK3' )
CREATE INDEX LSWC_ILDT_PK3 ON LSW_ILOG_DECISION(GUID) 
GO


ALTER  TABLE LSW_SNAPSHOT 
ADD 
ACTIVATED_ON DATETIME
GO


ALTER TABLE LSW_TIMING_INTERVAL ALTER COLUMN INTERVAL_START NVARCHAR(8) NULL
GO


ALTER TABLE LSW_TIMING_INTERVAL ALTER COLUMN INTERVAL_END NVARCHAR(8) NULL
GO


ALTER TABLE LSW_TIMING_INTERVAL_BOUND ALTER COLUMN BOUND NVARCHAR(8) NULL
GO


ALTER TABLE LSW_TRACKED_VARIABLE ALTER COLUMN TYPE NVARCHAR(8) NULL
GO


							BEGIN TRANSACTION;
							INSERT INTO LSW_CAPABILITY_TYPE (CAPABILITY_TYPE_ID,
							CAPABILITY_CONFIG_ID, NAME, DESCRIPTION, IS_OPTIONAL) VALUES(0,
							'Extended', 'BPM Extended', 'Description of BPM Extended
							Capability', 'F');
							INSERT INTO LSW_PRI_KEY(TABLE_ID, HIGH_KEY)
							VALUES('LSW_CAPABILITY_TYPE', 1000);
							COMMIT TRANSACTION;
                        
GO


ALTER TABLE LSW_DYNAMIC_GROUP ALTER COLUMN NAME NVARCHAR(128) NULL
GO


ALTER TABLE LSW_USR_GRP_XREF ALTER COLUMN DISPLAY_NAME NVARCHAR(128) NULL
GO


							INSERT INTO LSW_USR_GRP_MEM_XREF("GROUP_ID", "USER_ID") VALUES(11, 1)							      						      
						
GO


		
/* END of phase ProcUpgradeTo750 */

		
/* START of phase ProcUpgradeTo750Phase2 */
    
			
							DROP INDEX LSW_BRANCH.IDX2_BRANCH
                        
GO


ALTER TABLE LSW_BRANCH ALTER COLUMN NAME NVARCHAR(64) NOT NULL
GO


ALTER TABLE LSW_BRANCH ALTER COLUMN ACRONYM NVARCHAR(64) NOT NULL
GO


							CREATE INDEX IDX2_BRANCH ON LSW_BRANCH(NAME)
                        
GO


GO


ALTER TABLE LSW_SNAPSHOT ALTER COLUMN ACRONYM NVARCHAR(64) NOT NULL
GO


GO


							DROP INDEX LSW_PROJECT.IDX_SHORT_NAME
                        
GO


if not exists (select name from sys.indexes where name = 'IDX3_BRANCH' )
CREATE UNIQUE INDEX IDX3_BRANCH ON LSW_BRANCH(PROJECT_ID,ACRONYM)

GO


if not exists (select name from sys.indexes where name = 'IDX5_SNAPSHOT' )
CREATE UNIQUE INDEX IDX5_SNAPSHOT ON LSW_SNAPSHOT(PROJECT_ID,ACRONYM)

GO


if not exists (select name from sys.indexes where name = 'IDX_SHORT_NAME' )
CREATE INDEX IDX_SHORT_NAME ON LSW_PROJECT(SHORT_NAME) 
GO


if not exists (select name from sysobjects where name = 'LSW_ICMCASE_CONNECTOR')
CREATE  TABLE LSW_ICMCASE_CONNECTOR(
ICMCASE_CONNECTOR_ID UNIQUEIDENTIFIER NOT NULL,
DEFINITION IMAGE NOT NULL,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
GO


if not exists (select name from sysobjects where name = 'LSWC_ICNTR_PK' )     
ALTER TABLE LSW_ICMCASE_CONNECTOR ADD CONSTRAINT LSWC_ICNTR_PK
    PRIMARY KEY(VERSION_ID ) 
GO


if not exists (select name from sys.indexes where name = 'LSWC_ICNTR_PK3' )
CREATE INDEX LSWC_ICNTR_PK3 ON LSW_ICMCASE_CONNECTOR(GUID) 
GO


		
/* END of phase ProcUpgradeTo750Phase2 */

	
/*
 * MSSQL Upgrade Script for TeamWorks
 * From Version: TeamWorks 7.5.0
 * To Version: Teamworks 7.5.1
 */

    

		
/* START of phase ProcUpgradeTo751 */
    
			
ALTER  TABLE LSW_BPD 
ADD 
TYPE DECIMAL(2, 0)
GO


ALTER  TABLE LSW_BPD 
ADD 
ROOT_BPD_ID UNIQUEIDENTIFIER
GO


ALTER  TABLE LSW_BPD 
ADD 
PARENT_BPD_ID UNIQUEIDENTIFIER
GO


ALTER  TABLE LSW_BPD 
ADD 
PARENT_FLOW_OBJECT_ID NVARCHAR(128)
GO


ALTER  TABLE LSW_PROCESS 
ADD 
XML_DATA IMAGE
GO


ALTER  TABLE LSW_BPD 
ADD 
XML_DATA IMAGE
GO


ALTER  TABLE LSW_SCA_CONNECTOR 
ADD 
LAST_SYNCHRONIZED NVARCHAR(128)
GO


if exists (select name from sysobjects where name = 'LSW_DGRPC_FK' )
ALTER TABLE LSW_DYNAMIC_GROUP_CONSTRAINT DROP CONSTRAINT LSW_DGRPC_FK
GO


if exists (select name from sysobjects where name = 'LSWC_DPLPKG_FK1' )
ALTER TABLE LSW_DEPLOYMENT_PACKAGE DROP CONSTRAINT LSWC_DPLPKG_FK1
GO


ALTER TABLE LSW_DYNAMIC_GROUP_DEPENDENCY ALTER COLUMN PARENT_GROUP_ID DECIMAL(38,0) NOT NULL
GO
ALTER TABLE LSW_DYNAMIC_GROUP_DEPENDENCY ALTER COLUMN CHILD_GROUP_ID DECIMAL(38,0) NOT NULL
                      
GO


if not exists (select name from sysobjects where name = 'LSW_DGRPC_FK' )
ALTER TABLE LSW_DYNAMIC_GROUP_CONSTRAINT ADD CONSTRAINT LSW_DGRPC_FK
	FOREIGN KEY(DYNAMIC_GROUP_ID)
	REFERENCES LSW_DYNAMIC_GROUP(DYNAMIC_GROUP_ID)
	ON DELETE CASCADE
GO


if not exists (select name from sysobjects where name = 'LSWC_DPLPKG_FK1' )
ALTER TABLE LSW_DEPLOYMENT_PACKAGE ADD CONSTRAINT LSWC_DPLPKG_FK1
	FOREIGN KEY(SNAPSHOT_ID)
	REFERENCES LSW_SNAPSHOT(SNAPSHOT_ID)
	ON DELETE CASCADE
GO


if not exists (select name from sysobjects where name = 'LSWC_RT_UAD_FK' )
ALTER TABLE LSW_RT_USER_ATTRIBUTE_DEF ADD CONSTRAINT LSWC_RT_UAD_FK
	FOREIGN KEY(SNAPSHOT_ID)
	REFERENCES LSW_SNAPSHOT(SNAPSHOT_ID)
	ON DELETE CASCADE
GO


if not exists (select name from sysobjects where name = 'LSWC_FAV_TRK_FK' )
ALTER TABLE LSW_FAVORITE ADD CONSTRAINT LSWC_FAV_TRK_FK
	FOREIGN KEY(BRANCH_ID)
	REFERENCES LSW_BRANCH(BRANCH_ID)
	ON DELETE CASCADE
GO


if not exists (select name from sysobjects where name = 'LSWC_DGRP_TRK_FK' )
ALTER TABLE LSW_DYNAMIC_GROUP ADD CONSTRAINT LSWC_DGRP_TRK_FK
	FOREIGN KEY(BRANCH_ID)
	REFERENCES LSW_BRANCH(BRANCH_ID)
	ON DELETE CASCADE
GO


if not exists (select name from sysobjects where name = 'LSWC_DGRP_DEP_FK' )
ALTER TABLE LSW_DYNAMIC_GROUP_DEPENDENCY ADD CONSTRAINT LSWC_DGRP_DEP_FK
	FOREIGN KEY(PARENT_GROUP_ID)
	REFERENCES LSW_DYNAMIC_GROUP(DYNAMIC_GROUP_ID)
	ON DELETE CASCADE
GO


if not exists (select name from sysobjects where name = 'LSWC_DEP_SS_FK' )
ALTER TABLE LSW_DEPLOYMENT ADD CONSTRAINT LSWC_DEP_SS_FK
	FOREIGN KEY(SNAPSHOT_ID)
	REFERENCES LSW_SNAPSHOT(SNAPSHOT_ID)
	ON DELETE CASCADE
GO


if not exists (select name from sysobjects where name = 'LSWC_E_VAR_VAL_FK' )
ALTER TABLE LSW_ENV_VAR_VAL ADD CONSTRAINT LSWC_E_VAR_VAL_FK
	FOREIGN KEY(SNAPSHOT_ID)
	REFERENCES LSW_SNAPSHOT(SNAPSHOT_ID)
	ON DELETE CASCADE
GO


if not exists (select name from sysobjects where name = 'LSWC_SF_SS_FK' )
ALTER TABLE LSW_SMART_FOLDER ADD CONSTRAINT LSWC_SF_SS_FK
	FOREIGN KEY(SNAPSHOT_ID)
	REFERENCES LSW_SNAPSHOT(SNAPSHOT_ID)
	ON DELETE CASCADE
GO


ALTER  TABLE LSW_PROJECT_DEFAULTS 
ADD 
PARTICIPANT_REF UNIQUEIDENTIFIER
GO


ALTER  TABLE LSW_INST_MSG_EXCL 
ADD 
WAIT_ID DECIMAL(38,0)
GO


ALTER  TABLE LSW_PARTICIPANT 
ADD 
CURRENCY_CODE NCHAR(3)
GO


GO


GO


ALTER  TABLE LSW_USR_GRP_XREF 
ADD 
GROUP_STATE DECIMAL(2, 0) DEFAULT 0 NOT NULL
GO


INSERT INTO LSW_TASK_STATUS_CODES("STATUS_ID", "NAME", "STATUS_VALUE")
    VALUES(15, 'Followed', '70')
						
GO


							BEGIN TRANSACTION;
							INSERT INTO LSW_ENV_VAR_TYPE (ENV_VAR_TYPE_ID,NAME,DESCRIPTION)
							VALUES(4, 4, 'ICM Server');
							INSERT INTO LSW_ENV_VAR_TYPE (ENV_VAR_TYPE_ID,NAME,DESCRIPTION)
							VALUES(5, 5, 'Server Property');
							COMMIT TRANSACTION;
						
GO


		
/* END of phase ProcUpgradeTo751 */

	
/*
 * MSSQL Upgrade Script for TeamWorks
 * From Version: TeamWorks 7.5.1
 * To Version: Teamworks 8.0.0
 */

    

	    
/* START of phase ProcUpgradeTo800 */
    
			
INSERT INTO LSW_ENV_VAR_TYPE (ENV_VAR_TYPE_ID,NAME,DESCRIPTION)
    VALUES(7, '7', 'Sametime Server')
                        
GO


if not exists (select name from sysobjects where name = 'BPM_REGISTRATION')
CREATE  TABLE BPM_REGISTRATION(
REG_ID UNIQUEIDENTIFIER NOT NULL,
PC_URL NVARCHAR(256) NOT NULL,
PC_ID UNIQUEIDENTIFIER NOT NULL,
PC_NAME NVARCHAR(128) NOT NULL,
PC_VER NVARCHAR(16) NOT NULL,
REG_USER NVARCHAR(256) NOT NULL,
REGISTERED_ON DATETIME,
ACTIVE NCHAR(1) DEFAULT 'T' NOT NULL,
IS_INITIATOR NCHAR(1) DEFAULT 'T' NOT NULL)
GO


if not exists (select name from sysobjects where name = 'BPM_REGISTRATION_PK' )     
ALTER TABLE BPM_REGISTRATION ADD CONSTRAINT BPM_REGISTRATION_PK
    PRIMARY KEY(REG_ID ) 
GO


if not exists (select name from sysobjects where name = 'BPM_REPOSITORY_LOG')
CREATE  TABLE BPM_REPOSITORY_LOG(
REPOSITORY_LOG_ID UNIQUEIDENTIFIER NOT NULL,
PROJECT_ID UNIQUEIDENTIFIER,
ACTION_TYPE DECIMAL(8, 0) NOT NULL,
TARGET_ITEM_NAME NVARCHAR(198),
REPOSITORY_UUID UNIQUEIDENTIFIER,
CREATED_BY_USER NVARCHAR(256),
CREATED DATETIME,
PROPERTIES NTEXT)
GO


if not exists (select name from sysobjects where name = 'BPM_REPOSITORY_LOG_PK' )     
ALTER TABLE BPM_REPOSITORY_LOG ADD CONSTRAINT BPM_REPOSITORY_LOG_PK
    PRIMARY KEY(REPOSITORY_LOG_ID ) 
GO


if not exists (select name from sysobjects where name = 'BPM_SHARED_TK_USAGES')
CREATE  TABLE BPM_SHARED_TK_USAGES(
SHARED_TK_USAGE_ID UNIQUEIDENTIFIER NOT NULL,
PROJECT_ID UNIQUEIDENTIFIER NOT NULL,
SNAPSHOT_ID UNIQUEIDENTIFIER NOT NULL,
REGISTRATION_ID UNIQUEIDENTIFIER NOT NULL,
DEPENDENT_PROJECT_NAME NVARCHAR(128) NOT NULL,
IS_TOOLKIT NCHAR(1) DEFAULT 'F' NOT NULL)
GO


if not exists (select name from sysobjects where name = 'BPM_SHARED_TK_USAGES_PK' )     
ALTER TABLE BPM_SHARED_TK_USAGES ADD CONSTRAINT BPM_SHARED_TK_USAGES_PK
    PRIMARY KEY(SHARED_TK_USAGE_ID ) 
GO


ALTER  TABLE LSW_PROJECT 
ADD 
IS_SHARED NCHAR(1) DEFAULT 'F' NOT NULL
GO


ALTER  TABLE LSW_PROJECT 
ADD 
SHARED_BY_USER_ID DECIMAL(38,0)
GO


ALTER  TABLE LSW_PROJECT 
ADD 
SHARED_ON DATETIME
GO


if not exists (select name from sysobjects where name = 'BPM_SHARED_OBJECT')
CREATE  TABLE BPM_SHARED_OBJECT(
DEFINITION_VERSION_ID UNIQUEIDENTIFIER NOT NULL,
OBJECT_ID UNIQUEIDENTIFIER NOT NULL,
DEFINITION_VERSION DECIMAL(38,0) NOT NULL,
CLASS_VERSION_ID UNIQUEIDENTIFIER NOT NULL,
BPD_INSTANCE_ID DECIMAL(38,0),
TASK_ID DECIMAL(38,0),
CREATED_BY_USER_ID DECIMAL(38,0) NOT NULL,
CREATED_ON DATETIME NOT NULL)
GO


if not exists (select name from sysobjects where name = 'BPM_SHARED_OBJECT_INSTANCE')
CREATE  TABLE BPM_SHARED_OBJECT_INSTANCE(
INSTANCE_VERSION_ID UNIQUEIDENTIFIER NOT NULL,
INSTANCE_VERSION DECIMAL(38,0) NOT NULL,
DEFINITION_VERSION_ID UNIQUEIDENTIFIER NOT NULL,
JDATA IMAGE,
CREATED_BY_USER_ID DECIMAL(38,0) NOT NULL,
CREATED_ON DATETIME NOT NULL)
GO


if not exists (select name from sysobjects where name = 'BPM_SHARED_OBJECT_VALUE')
CREATE  TABLE BPM_SHARED_OBJECT_VALUE(
VALUE_ID UNIQUEIDENTIFIER NOT NULL,
INSTANCE_VERSION_ID UNIQUEIDENTIFIER NOT NULL,
FIELD_PATH NVARCHAR(1024) NOT NULL,
VALUE IMAGE,
PRIOR_VALUE IMAGE)
GO


if not exists (select name from sysobjects where name = 'BPM_SHARED_OBJECT_PK' )     
ALTER TABLE BPM_SHARED_OBJECT ADD CONSTRAINT BPM_SHARED_OBJECT_PK
    PRIMARY KEY(DEFINITION_VERSION_ID ) 
GO


if not exists (select name from sysobjects where name = 'BPM_SHARED_OBJECT_INSTANCE_PK' )     
ALTER TABLE BPM_SHARED_OBJECT_INSTANCE ADD CONSTRAINT BPM_SHARED_OBJECT_INSTANCE_PK
    PRIMARY KEY(INSTANCE_VERSION_ID ) 
GO


if not exists (select name from sysobjects where name = 'BPM_SHARED_OBJECT_VALUE_PK' )     
ALTER TABLE BPM_SHARED_OBJECT_VALUE ADD CONSTRAINT BPM_SHARED_OBJECT_VALUE_PK
    PRIMARY KEY(VALUE_ID ) 
GO


if not exists (select name from sysobjects where name = 'BPM_SHARED_OBJECT_FK' )
ALTER TABLE BPM_SHARED_OBJECT ADD CONSTRAINT BPM_SHARED_OBJECT_FK
	FOREIGN KEY(CLASS_VERSION_ID)
	REFERENCES LSW_CLASS(VERSION_ID)
	
GO


if not exists (select name from sysobjects where name = 'BPM_SHARED_OBJ_TO_INSTANCE' )
ALTER TABLE BPM_SHARED_OBJECT ADD CONSTRAINT BPM_SHARED_OBJ_TO_INSTANCE
	FOREIGN KEY(BPD_INSTANCE_ID)
	REFERENCES LSW_BPD_INSTANCE(BPD_INSTANCE_ID)
	ON DELETE CASCADE
GO


if not exists (select name from sysobjects where name = 'BPM_SHARED_OBJ_TO_TASK' )
ALTER TABLE BPM_SHARED_OBJECT ADD CONSTRAINT BPM_SHARED_OBJ_TO_TASK
	FOREIGN KEY(TASK_ID)
	REFERENCES LSW_TASK(TASK_ID)
	ON DELETE CASCADE
GO


if not exists (select name from sys.indexes where name = 'BPM_SHARED_OBJECT_UQ' )
CREATE UNIQUE INDEX BPM_SHARED_OBJECT_UQ ON BPM_SHARED_OBJECT(OBJECT_ID,DEFINITION_VERSION)

GO


if not exists (select name from sysobjects where name = 'BPM_SHARED_OBJECT_INSTANCE_FK' )
ALTER TABLE BPM_SHARED_OBJECT_INSTANCE ADD CONSTRAINT BPM_SHARED_OBJECT_INSTANCE_FK
	FOREIGN KEY(DEFINITION_VERSION_ID)
	REFERENCES BPM_SHARED_OBJECT(DEFINITION_VERSION_ID)
	ON DELETE CASCADE
GO


if not exists (select name from sys.indexes where name = 'BPM_SHARED_OBJECT_INSTANCE_UQ' )
CREATE UNIQUE INDEX BPM_SHARED_OBJECT_INSTANCE_UQ ON BPM_SHARED_OBJECT_INSTANCE(DEFINITION_VERSION_ID,INSTANCE_VERSION)

GO


if not exists (select name from sysobjects where name = 'BPM_SHARED_OBJECT_VALUE_FK' )
ALTER TABLE BPM_SHARED_OBJECT_VALUE ADD CONSTRAINT BPM_SHARED_OBJECT_VALUE_FK
	FOREIGN KEY(INSTANCE_VERSION_ID)
	REFERENCES BPM_SHARED_OBJECT_INSTANCE(INSTANCE_VERSION_ID)
	ON DELETE CASCADE
GO


ALTER  TABLE LSW_PROJECT 
ADD 
IS_GOVERNED NCHAR(1) DEFAULT 'F' NOT NULL
GO


ALTER  TABLE LSW_PO_VERSIONS 
ADD 
PO_ORIG_VERSION_ID UNIQUEIDENTIFIER
GO


ALTER  TABLE LSW_PO_VERSIONS 
ADD 
ORIG_LAST_MODIFIED_BY_USER NVARCHAR(50)
GO


ALTER  TABLE LSW_PO_VERSIONS 
ADD 
ORIG_LAST_MODIFIED DATETIME
GO


ALTER  TABLE LSW_SNAPSHOT 
ADD 
STATUS NVARCHAR(64) DEFAULT 'New' NOT NULL
GO


ALTER  TABLE LSW_TASK 
ADD 
COLLABORATION NCHAR(1) DEFAULT 'F' NOT NULL
GO


ALTER  TABLE LSW_DEPLOYMENT 
ADD 
STATUS NVARCHAR(64)
GO


ALTER  TABLE LSW_DEPLOYMENT 
ADD 
STATE DECIMAL(2, 0) DEFAULT 0 NOT NULL
GO


ALTER  TABLE LSW_DEPLOYMENT 
ADD 
STATUS_DESCRIPTION NVARCHAR(250)
GO


if not exists (select name from sysobjects where name = 'BPM_SNAPSHOT_STATUS')
CREATE  TABLE BPM_SNAPSHOT_STATUS(
STATUS_ID UNIQUEIDENTIFIER NOT NULL,
STATUS NVARCHAR(64) NOT NULL,
IS_SYSTEM NCHAR(1) DEFAULT 'F' NOT NULL)
GO


if not exists (select name from sysobjects where name = 'BPM_SNAPSHOT_STATUS_PK' )     
ALTER TABLE BPM_SNAPSHOT_STATUS ADD CONSTRAINT BPM_SNAPSHOT_STATUS_PK
    PRIMARY KEY(STATUS_ID ) 
GO


							BEGIN TRANSACTION;
								INSERT INTO BPM_SNAPSHOT_STATUS(STATUS_ID, STATUS, IS_SYSTEM) VALUES('1b351583-e5cb-43b7-baee-340a63130ea1', 'New', 'T');
								INSERT INTO BPM_SNAPSHOT_STATUS(STATUS_ID, STATUS, IS_SYSTEM) VALUES('1b351583-e5cb-43b7-baee-340a63130ea2', 'Rejected', 'T');
								INSERT INTO BPM_SNAPSHOT_STATUS(STATUS_ID, STATUS, IS_SYSTEM) VALUES('1b351583-e5cb-43b7-baee-340a63130ea3', 'Validated', 'T');
								INSERT INTO BPM_SNAPSHOT_STATUS(STATUS_ID, STATUS, IS_SYSTEM) VALUES('1b351583-e5cb-43b7-baee-340a63130ea7', 'Released', 'T');
							COMMIT
							TRANSACTION;
						
GO


if not exists (select name from sysobjects where name = 'BPM_COACH_VIEW')
CREATE  TABLE BPM_COACH_VIEW(
COACH_VIEW_ID UNIQUEIDENTIFIER NOT NULL,
IS_TEMPLATE NCHAR(1),
LAYOUT IMAGE,
PALETTE_ICON UNIQUEIDENTIFIER,
PREVIEW_IMAGE UNIQUEIDENTIFIER,
HAS_LABEL NCHAR(1),
LABEL_POSITION DECIMAL(2, 0),
NINE_SLICE_X1_COORD DECIMAL(5, 0),
NINE_SLICE_X2_COORD DECIMAL(5, 0),
NINE_SLICE_Y1_COORD DECIMAL(5, 0),
NINE_SLICE_Y2_COORD DECIMAL(5, 0),
EMIT_BOUNDARY NCHAR(1),
LOAD_JS_FUNCTION NTEXT,
UNLOAD_JS_FUNCTION NTEXT,
VIEW_JS_FUNCTION NTEXT,
CHANGE_JS_FUNCTION NTEXT,
COLLABORATION_JS_FUNCTION NTEXT,
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
GO


if not exists (select name from sysobjects where name = 'BPM_CH_VIEW_PK' )     
ALTER TABLE BPM_COACH_VIEW ADD CONSTRAINT BPM_CH_VIEW_PK
    PRIMARY KEY(VERSION_ID ) 
GO


if not exists (select name from sys.indexes where name = 'BPM_CH_VIEW_PK3' )
CREATE INDEX BPM_CH_VIEW_PK3 ON BPM_COACH_VIEW(GUID) 
GO


if not exists (select name from sysobjects where name = 'BPM_COACH_VIEW_BINDING_TYPE')
CREATE  TABLE BPM_COACH_VIEW_BINDING_TYPE(
COACH_VIEW_BINDING_TYPE_ID UNIQUEIDENTIFIER NOT NULL,
COACH_VIEW_ID UNIQUEIDENTIFIER NOT NULL,
IS_LIST NCHAR(1),
CLASS_ID UNIQUEIDENTIFIER,
SEQ DECIMAL(38,0),
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
GO


if not exists (select name from sysobjects where name = 'BPM_VIEW_BIND_PK' )     
ALTER TABLE BPM_COACH_VIEW_BINDING_TYPE ADD CONSTRAINT BPM_VIEW_BIND_PK
    PRIMARY KEY(VERSION_ID ) 
GO


if not exists (select name from sys.indexes where name = 'BPM_VIEW_BIND_PK3' )
CREATE INDEX BPM_VIEW_BIND_PK3 ON BPM_COACH_VIEW_BINDING_TYPE(GUID) 
GO


if not exists (select name from sys.indexes where name = 'IDX_VIEW_BIND' )
CREATE INDEX IDX_VIEW_BIND ON BPM_COACH_VIEW_BINDING_TYPE(SEQ) 
GO


if not exists (select name from sysobjects where name = 'BPM_COACH_VIEW_CONFIG_OPTION')
CREATE  TABLE BPM_COACH_VIEW_CONFIG_OPTION(
COACH_VIEW_CONFIG_OPTION_ID UNIQUEIDENTIFIER NOT NULL,
COACH_VIEW_ID UNIQUEIDENTIFIER NOT NULL,
IS_LIST NCHAR(1),
PROPERTY_TYPE NVARCHAR(64),
LABEL NVARCHAR(64),
CLASS_ID UNIQUEIDENTIFIER,
PROCESS_ID UNIQUEIDENTIFIER,
SEQ DECIMAL(38,0),
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
GO


if not exists (select name from sysobjects where name = 'BPM_VIEW_CONFIG_PK' )     
ALTER TABLE BPM_COACH_VIEW_CONFIG_OPTION ADD CONSTRAINT BPM_VIEW_CONFIG_PK
    PRIMARY KEY(VERSION_ID ) 
GO


if not exists (select name from sys.indexes where name = 'BPM_VIEW_CONFIG_PK3' )
CREATE INDEX BPM_VIEW_CONFIG_PK3 ON BPM_COACH_VIEW_CONFIG_OPTION(GUID) 
GO


if not exists (select name from sys.indexes where name = 'IDX_VIEW_CONFIG' )
CREATE INDEX IDX_VIEW_CONFIG ON BPM_COACH_VIEW_CONFIG_OPTION(SEQ) 
GO


if not exists (select name from sysobjects where name = 'BPM_COACH_VIEW_RESOURCE')
CREATE  TABLE BPM_COACH_VIEW_RESOURCE(
COACH_VIEW_RESOURCE_ID UNIQUEIDENTIFIER NOT NULL,
COACH_VIEW_ID UNIQUEIDENTIFIER NOT NULL,
FILE_PATH NVARCHAR(255),
IE_CONDITION NVARCHAR(1024),
MEDIA_QUERY NVARCHAR(1024),
ASSET_UUID UNIQUEIDENTIFIER,
SEQ DECIMAL(38,0),
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
GO


if not exists (select name from sysobjects where name = 'BPM_VIEW_RES_PK' )     
ALTER TABLE BPM_COACH_VIEW_RESOURCE ADD CONSTRAINT BPM_VIEW_RES_PK
    PRIMARY KEY(VERSION_ID ) 
GO


if not exists (select name from sys.indexes where name = 'BPM_VIEW_RES_PK3' )
CREATE INDEX BPM_VIEW_RES_PK3 ON BPM_COACH_VIEW_RESOURCE(GUID) 
GO


if not exists (select name from sys.indexes where name = 'IDX_VIEW_RES' )
CREATE INDEX IDX_VIEW_RES ON BPM_COACH_VIEW_RESOURCE(SEQ) 
GO


if not exists (select name from sysobjects where name = 'BPM_COACH_VIEW_INLINE_SCRIPT')
CREATE  TABLE BPM_COACH_VIEW_INLINE_SCRIPT(
COACH_VIEW_INLINE_SCRIPT_ID UNIQUEIDENTIFIER NOT NULL,
COACH_VIEW_ID UNIQUEIDENTIFIER NOT NULL,
SCRIPT_TYPE NVARCHAR(64),
SCRIPT_BLOCK NTEXT,
SEQ DECIMAL(38,0),
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
GO


if not exists (select name from sysobjects where name = 'BPM_VIEW_SCRIPT_PK' )     
ALTER TABLE BPM_COACH_VIEW_INLINE_SCRIPT ADD CONSTRAINT BPM_VIEW_SCRIPT_PK
    PRIMARY KEY(VERSION_ID ) 
GO


if not exists (select name from sys.indexes where name = 'BPM_VIEW_SCRIPT_PK3' )
CREATE INDEX BPM_VIEW_SCRIPT_PK3 ON BPM_COACH_VIEW_INLINE_SCRIPT(GUID) 
GO


if not exists (select name from sys.indexes where name = 'IDX_VIEW_SCRIPT' )
CREATE INDEX IDX_VIEW_SCRIPT ON BPM_COACH_VIEW_INLINE_SCRIPT(SEQ) 
GO


if not exists (select name from sysobjects where name = 'BPM_COACHNG')
CREATE  TABLE BPM_COACHNG(
COACHNG_ID UNIQUEIDENTIFIER NOT NULL,
TITLE NVARCHAR(64),
LAYOUT_DATA IMAGE,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
GO


if not exists (select name from sysobjects where name = 'BPM_COACHNG_PK' )     
ALTER TABLE BPM_COACHNG ADD CONSTRAINT BPM_COACHNG_PK
    PRIMARY KEY(VERSION_ID ) 
GO


if not exists (select name from sys.indexes where name = 'BPM_COACHNG_PK3' )
CREATE INDEX BPM_COACHNG_PK3 ON BPM_COACHNG(GUID) 
GO


if not exists (select name from sysobjects where name = 'BPM_COACHNG_BOUNDARY_EVENT')
CREATE  TABLE BPM_COACHNG_BOUNDARY_EVENT(
COACHNG_BOUNDARY_EVENT_ID UNIQUEIDENTIFIER NOT NULL,
COACHNG_ID UNIQUEIDENTIFIER NOT NULL,
SEQ DECIMAL(38,0) NOT NULL,
END_STATE_ID NVARCHAR(128) NOT NULL,
EVENT_LABEL NTEXT,
VIEW_PATH NTEXT,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
GO


if not exists (select name from sysobjects where name = 'BPM_COACHNG_BE_PK' )     
ALTER TABLE BPM_COACHNG_BOUNDARY_EVENT ADD CONSTRAINT BPM_COACHNG_BE_PK
    PRIMARY KEY(VERSION_ID ) 
GO


if not exists (select name from sys.indexes where name = 'BPM_COACHNG_BE_PK3' )
CREATE INDEX BPM_COACHNG_BE_PK3 ON BPM_COACHNG_BOUNDARY_EVENT(GUID) 
GO


if not exists (select name from sys.indexes where name = 'IDX_COACHNG_BE' )
CREATE INDEX IDX_COACHNG_BE ON BPM_COACHNG_BOUNDARY_EVENT(COACHNG_ID,SEQ) 
GO


if not exists (select name from sysobjects where name = 'BPM_COACH_VIEW_LOCAL_RES')
CREATE  TABLE BPM_COACH_VIEW_LOCAL_RES(
COACH_VIEW_LOCAL_RES_ID UNIQUEIDENTIFIER NOT NULL,
COACH_VIEW_ID UNIQUEIDENTIFIER NOT NULL,
RESOURCE_BUNDLE_GROUP_ID UNIQUEIDENTIFIER NOT NULL,
SEQ DECIMAL(38,0),
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
GO


if not exists (select name from sysobjects where name = 'BPM_VIEW_LOC_PK' )     
ALTER TABLE BPM_COACH_VIEW_LOCAL_RES ADD CONSTRAINT BPM_VIEW_LOC_PK
    PRIMARY KEY(VERSION_ID ) 
GO


if not exists (select name from sys.indexes where name = 'BPM_VIEW_LOC_PK3' )
CREATE INDEX BPM_VIEW_LOC_PK3 ON BPM_COACH_VIEW_LOCAL_RES(GUID) 
GO


if not exists (select name from sysobjects where name = 'BPM_COACH_VIEW_AMD_DEP')
CREATE  TABLE BPM_COACH_VIEW_AMD_DEP(
COACH_VIEW_AMD_DEP_ID UNIQUEIDENTIFIER NOT NULL,
COACH_VIEW_ID UNIQUEIDENTIFIER NOT NULL,
MODULE_ID NVARCHAR(1024),
FUNCTION_ARGUMENT NVARCHAR(255),
SEQ DECIMAL(38,0),
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
GO


if not exists (select name from sysobjects where name = 'BPM_VIEW_AMD_PK' )     
ALTER TABLE BPM_COACH_VIEW_AMD_DEP ADD CONSTRAINT BPM_VIEW_AMD_PK
    PRIMARY KEY(VERSION_ID ) 
GO


if not exists (select name from sys.indexes where name = 'BPM_VIEW_AMD_PK3' )
CREATE INDEX BPM_VIEW_AMD_PK3 ON BPM_COACH_VIEW_AMD_DEP(GUID) 
GO


if not exists (select name from sys.indexes where name = 'IDX_VIEW_AMD' )
CREATE INDEX IDX_VIEW_AMD ON BPM_COACH_VIEW_AMD_DEP(SEQ) 
GO


							BEGIN TRANSACTION;
								INSERT INTO LSW_TASK_STATUS_CODES("STATUS_ID", "NAME", "STATUS_VALUE") VALUES(16, 'Tagged', 71);
								INSERT INTO LSW_TASK_STATUS_CODES("STATUS_ID", "NAME", "STATUS_VALUE") VALUES(17, 'Collaboration', 72);
							COMMIT
							TRANSACTION;
						
GO


if not exists (select name from sysobjects where name = 'BPM_PROJECT_SUBSCRIPTION')
CREATE  TABLE BPM_PROJECT_SUBSCRIPTION(
PROJECT_SUBSCRIPTION_ID UNIQUEIDENTIFIER NOT NULL,
REGISTRATION_ID UNIQUEIDENTIFIER NOT NULL,
PROJECT_ID UNIQUEIDENTIFIER NOT NULL,
SUBSCRIBED_BY DECIMAL(38,0) NOT NULL,
SUBSCRIBED_ON DATETIME NOT NULL,
STATUS NVARCHAR(64),
ACTIVE NCHAR(1) DEFAULT 'F' NOT NULL,
SHARED_BY_USER_ID NVARCHAR(256),
SHARED_ON DATETIME,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
GO


if not exists (select name from sysobjects where name = 'BPM_PROJECT_SUBSCRIPTION_PK' )     
ALTER TABLE BPM_PROJECT_SUBSCRIPTION ADD CONSTRAINT BPM_PROJECT_SUBSCRIPTION_PK
    PRIMARY KEY(PROJECT_SUBSCRIPTION_ID ) 
GO


if not exists (select name from sys.indexes where name = 'PROJECT_ID_UQ' )
CREATE UNIQUE INDEX PROJECT_ID_UQ ON BPM_PROJECT_SUBSCRIPTION(PROJECT_ID)

GO


if not exists (select name from sysobjects where name = 'BPM_PROJECT_SUBSCRIBED')
CREATE  TABLE BPM_PROJECT_SUBSCRIBED(
PROJECT_SUBSCRIBED_ID UNIQUEIDENTIFIER NOT NULL,
REGISTRATION_ID UNIQUEIDENTIFIER NOT NULL,
PROJECT_ID UNIQUEIDENTIFIER NOT NULL,
SUBSCRIBED_BY NVARCHAR(256) NOT NULL,
SUBSCRIBED_ON DATETIME NOT NULL,
LAST_MODIFICATION DATETIME)
GO


if not exists (select name from sysobjects where name = 'BPM_PROJECT_SUBSCRIBED_PK' )     
ALTER TABLE BPM_PROJECT_SUBSCRIBED ADD CONSTRAINT BPM_PROJECT_SUBSCRIBED_PK
    PRIMARY KEY(PROJECT_SUBSCRIBED_ID ) 
GO


ALTER  TABLE LSW_TASK 
ADD 
EXPERT_PARTICIPANT_REF DECIMAL(38,0)
GO


ALTER  TABLE LSW_SNAPSHOT 
ADD 
LAST_MODIFIED DATETIME DEFAULT CURRENT_TIMESTAMP NOT NULL
GO


GO


ALTER  TABLE LSW_SNAPSHOT 
ADD 
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) DEFAULT 1 NOT NULL
GO


ALTER  TABLE LSW_TASK 
ADD 
AT_RISK_DATE DATETIME
GO


ALTER  TABLE LSW_CLASS 
ADD 
SHARED NCHAR(1)
GO


if not exists (select name from sysobjects where name = 'BPM_USR_AVATAR')
CREATE  TABLE BPM_USR_AVATAR(
USER_ID DECIMAL(38,0) NOT NULL,
USER_AVATAR_IMAGE IMAGE)
GO


if not exists (select name from sysobjects where name = 'LSWC_USR_AVATAR_PK' )     
ALTER TABLE BPM_USR_AVATAR ADD CONSTRAINT LSWC_USR_AVATAR_PK
    PRIMARY KEY(USER_ID ) 
GO


if not exists (select name from sysobjects where name = 'LSWC_USR_AVATAR_FK' )
ALTER TABLE BPM_USR_AVATAR ADD CONSTRAINT LSWC_USR_AVATAR_FK
	FOREIGN KEY(USER_ID)
	REFERENCES LSW_USR_XREF(USER_ID)
	
GO


if not exists (select name from sysobjects where name = 'BPM_TASK_ACTIVITY_MEASURES')
CREATE  TABLE BPM_TASK_ACTIVITY_MEASURES(
TASK_MEASURES_ID DECIMAL(38,0) NOT NULL,
CREATED_BY_BPD_FLOW_OBJECT_ID NVARCHAR(512) NOT NULL,
USER_ID DECIMAL(38,0),
COMPLETION_COUNT DECIMAL(8, 0) NOT NULL,
AVG_COMPLETION_TIME DECIMAL(38,0) NOT NULL)
GO


if not exists (select name from sysobjects where name = 'TASK_MEASURES_PK' )     
ALTER TABLE BPM_TASK_ACTIVITY_MEASURES ADD CONSTRAINT TASK_MEASURES_PK
    PRIMARY KEY(TASK_MEASURES_ID ) 
GO


if not exists (select name from sys.indexes where name = 'TASK_MEASURES_UC' )
CREATE UNIQUE INDEX TASK_MEASURES_UC ON BPM_TASK_ACTIVITY_MEASURES(CREATED_BY_BPD_FLOW_OBJECT_ID,USER_ID)

GO


ALTER  TABLE LSW_SERVER 
ADD 
IS_ENCRYPTED NCHAR(1) DEFAULT '0'
GO


ALTER TABLE LSW_SERVER ALTER COLUMN PASSWORD NVARCHAR(250) NULL
GO


if not exists (select name from sysobjects where name = 'BPM_OSLC_PROVIDER')
CREATE  TABLE BPM_OSLC_PROVIDER(
PROVIDER_ID UNIQUEIDENTIFIER NOT NULL,
NAME NVARCHAR(256),
URL NVARCHAR(1024) NOT NULL,
DATA NTEXT,
CREATED_BY_USER_ID DECIMAL(38,0) NOT NULL,
CREATED_ON DATETIME NOT NULL)
GO


if not exists (select name from sysobjects where name = 'LSWC_OSLC_PROVIDER' )     
ALTER TABLE BPM_OSLC_PROVIDER ADD CONSTRAINT LSWC_OSLC_PROVIDER
    PRIMARY KEY(PROVIDER_ID ) 
GO


if not exists (select name from sysobjects where name = 'BPM_PC_IDX_ACTION')
CREATE  TABLE BPM_PC_IDX_ACTION(
ACTION_ID UNIQUEIDENTIFIER NOT NULL,
PO_ID UNIQUEIDENTIFIER NOT NULL,
PO_TYPE DECIMAL(8, 0) NOT NULL,
USER_ACTION DECIMAL(8, 0) NOT NULL,
CREATED_BY_USER_ID DECIMAL(38,0) NOT NULL,
CREATED_ON DATETIME NOT NULL)
GO


if not exists (select name from sysobjects where name = 'BPM_PC_IDX_ACTION_PK' )     
ALTER TABLE BPM_PC_IDX_ACTION ADD CONSTRAINT BPM_PC_IDX_ACTION_PK
    PRIMARY KEY(ACTION_ID ) 
GO


if not exists (select name from sysobjects where name = 'BPM_TASK_MARKERS')
CREATE  TABLE BPM_TASK_MARKERS(
MARKER_ID DECIMAL(38,0) NOT NULL,
TASK_ID DECIMAL(38,0),
MARKER_TYPE DECIMAL(38,0) NOT NULL,
CREATOR DECIMAL(38,0) NOT NULL,
TARGET_USER DECIMAL(38,0) NOT NULL,
MARKER_COMMENT IMAGE,
CREATED_DATE DATETIME NOT NULL,
BPD_INSTANCE_ID DECIMAL(38,0))
GO


if not exists (select name from sysobjects where name = 'BPMC_TASK_MARKERS' )     
ALTER TABLE BPM_TASK_MARKERS ADD CONSTRAINT BPMC_TASK_MARKERS
    PRIMARY KEY(MARKER_ID ) 
GO


if not exists (select name from sysobjects where name = 'BPMC_MARKER_TO_TASK_ID_FK' )
ALTER TABLE BPM_TASK_MARKERS ADD CONSTRAINT BPMC_MARKER_TO_TASK_ID_FK
	FOREIGN KEY(TASK_ID)
	REFERENCES LSW_TASK(TASK_ID)
	ON DELETE CASCADE
GO


if not exists (select name from sysobjects where name = 'BPMC_MARKER_TO_BPD_ID_FK' )
ALTER TABLE BPM_TASK_MARKERS ADD CONSTRAINT BPMC_MARKER_TO_BPD_ID_FK
	FOREIGN KEY(BPD_INSTANCE_ID)
	REFERENCES LSW_BPD_INSTANCE(BPD_INSTANCE_ID)
	ON DELETE CASCADE
GO



								CREATE TABLE [BPM_PCS_TASK] ( [TASKID] BIGINT NOT NULL ,
								               [VERSION] VARCHAR(5) NOT NULL ,
								               [ROW_VERSION] INT NOT NULL ,
								               [TASKTYPE] INT NOT NULL ,
								               [TASKSUSPENDED] TINYINT NOT NULL ,
								               [CANCELLED] TINYINT NOT NULL ,
								               [NEXTFIRETIME] BIGINT NOT NULL ,
								               [STARTBYINTERVAL] VARCHAR(254) NULL ,
								               [STARTBYTIME] BIGINT NULL ,
								               [VALIDFROMTIME] BIGINT NULL ,
								               [VALIDTOTIME] BIGINT NULL ,
								               [REPEATINTERVAL] VARCHAR(254) NULL ,
								               [MAXREPEATS] INT NOT NULL ,
								               [REPEATSLEFT] INT NOT NULL ,
								               [TASKINFO] IMAGE NULL ,
								               [NAME] VARCHAR(254) NOT NULL ,
								               [AUTOPURGE] INT NOT NULL ,
								               [FAILUREACTION] INT NULL ,
								               [MAXATTEMPTS] INT NULL ,
								               [QOS] INT NULL ,
								               [PARTITIONID] INT NULL ,
								               [OWNERTOKEN] VARCHAR(200) NOT NULL ,
								               [CREATETIME] BIGINT NOT NULL ) 
								GO
								 
								ALTER TABLE [BPM_PCS_TASK] WITH NOCHECK ADD CONSTRAINT [BPM_PCS_TASK_PK] PRIMARY KEY  NONCLUSTERED ( [TASKID] ) 
								GO
								
								CREATE INDEX [BPM_PCS_TASK_IDX1] ON [BPM_PCS_TASK] ( [TASKID],
								               [OWNERTOKEN] ) 
								GO
								
								CREATE CLUSTERED INDEX [BPM_PCS_TASK_IDX2] ON [BPM_PCS_TASK] ( [NEXTFIRETIME] ASC,
								               [REPEATSLEFT],
								               [PARTITIONID] )
								GO
								
								CREATE TABLE [BPM_PCS_TREG] ( [REGKEY] VARCHAR(254) NOT NULL ,
								               [REGVALUE] VARCHAR(254) NULL ,
								               PRIMARY KEY ( [REGKEY] ) )
								GO
								
								CREATE TABLE [BPM_PCS_LMGR] ( [LEASENAME] VARCHAR(254) NOT NULL,
								               [LEASEOWNER] VARCHAR(254) NOT NULL,
								               [LEASE_EXPIRE_TIME] BIGINT,
								               [DISABLED] VARCHAR(5) )
								GO
								
								ALTER TABLE [BPM_PCS_LMGR] WITH NOCHECK ADD CONSTRAINT [BPM_PCS_LMGR_PK] PRIMARY KEY  NONCLUSTERED ( [LEASENAME] ) 
								GO
								
								CREATE TABLE [BPM_PCS_LMPR] ( [LEASENAME] VARCHAR(254) NOT NULL,
								               [NAME] VARCHAR(254) NOT NULL,
								               [VALUE] VARCHAR(254) NOT NULL )
								GO
								
								CREATE INDEX [BPM_PCS_LMPR_IDX1] ON [BPM_PCS_LMPR] ( [LEASENAME],
								               [NAME] ) 
								GO


              			
GO


if not exists (select name from sysobjects where name = 'BPM_PC_INDEXER')
CREATE  TABLE BPM_PC_INDEXER(
INDEXER_ID UNIQUEIDENTIFIER NOT NULL,
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT,
LAST_INDEXED_ON DATETIME NOT NULL)
GO


if not exists (select name from sysobjects where name = 'BPM_PC_IDEXER_PK' )     
ALTER TABLE BPM_PC_INDEXER ADD CONSTRAINT BPM_PC_IDEXER_PK
    PRIMARY KEY(INDEXER_ID ) 
GO


if not exists (select name from sys.indexes where name = 'BPM_PC_IDEXER_UQ' )
CREATE UNIQUE INDEX BPM_PC_IDEXER_UQ ON BPM_PC_INDEXER(NAME)

GO


ALTER  TABLE LSW_EXCEPTION 
ADD 
ATTACHED_PROCESS_REF UNIQUEIDENTIFIER
GO


ALTER  TABLE LSW_EXCEPTION 
ADD 
FAULT_STYLE DECIMAL(2, 0)
GO


ALTER  TABLE LSW_RUNTIME_ERROR 
ADD 
ERROR_CODE NVARCHAR(220)
GO


ALTER  TABLE LSW_RUNTIME_ERROR 
ADD 
ERROR_DATA IMAGE
GO


ALTER  TABLE LSW_RUNTIME_ERROR 
ADD 
FAULT_STYLE DECIMAL(2, 0) DEFAULT 0 NOT NULL
GO


if not exists (select name from sysobjects where name = 'LSW_STORED_SYMBOL_TABLE')
CREATE  TABLE LSW_STORED_SYMBOL_TABLE(
SYMBOL_TABLE_ID UNIQUEIDENTIFIER NOT NULL,
TASK_ID DECIMAL(38,0) NOT NULL,
STORED_SYMBOL_TABLE IMAGE)
GO


if not exists (select name from sysobjects where name = 'LSWC_STORED_SYMBOL_PK' )     
ALTER TABLE LSW_STORED_SYMBOL_TABLE ADD CONSTRAINT LSWC_STORED_SYMBOL_PK
    PRIMARY KEY(SYMBOL_TABLE_ID ) 
GO


if not exists (select name from sysobjects where name = 'LSWC_T_SYM_FK' )
ALTER TABLE LSW_STORED_SYMBOL_TABLE ADD CONSTRAINT LSWC_T_SYM_FK
	FOREIGN KEY(TASK_ID)
	REFERENCES LSW_TASK(TASK_ID)
	ON DELETE CASCADE
GO


if not exists (select name from sys.indexes where name = 'LSWC_T_SYM_TASK' )
CREATE UNIQUE INDEX LSWC_T_SYM_TASK ON LSW_STORED_SYMBOL_TABLE(TASK_ID)

GO


if not exists (select name from sysobjects where name = 'BPM_ECM_CONNECTOR')
CREATE  TABLE BPM_ECM_CONNECTOR(
ECM_CONNECTOR_ID UNIQUEIDENTIFIER NOT NULL,
DEFINITION IMAGE NOT NULL,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
GO


if not exists (select name from sysobjects where name = 'BPMC_ECNTR_PK' )     
ALTER TABLE BPM_ECM_CONNECTOR ADD CONSTRAINT BPMC_ECNTR_PK
    PRIMARY KEY(VERSION_ID ) 
GO


if not exists (select name from sys.indexes where name = 'BPMC_ECNTR_PK3' )
CREATE INDEX BPMC_ECNTR_PK3 ON BPM_ECM_CONNECTOR(GUID) 
GO


ALTER  TABLE LSW_CLASS 
ADD 
LIFETIME NCHAR(1)
GO


if not exists (select name from sysobjects where name = 'BPM_BPD_SOAPHEADER')
CREATE  TABLE BPM_BPD_SOAPHEADER(
BPD_INSTANCE_ID DECIMAL(38,0) NOT NULL,
DATA IMAGE)
GO


if not exists (select name from sysobjects where name = 'BPMC_BPD_SOAP_FK0' )
ALTER TABLE BPM_BPD_SOAPHEADER ADD CONSTRAINT BPMC_BPD_SOAP_FK0
	FOREIGN KEY(BPD_INSTANCE_ID)
	REFERENCES LSW_BPD_INSTANCE(BPD_INSTANCE_ID)
	ON DELETE CASCADE
GO


if not exists (select name from sys.indexes where name = 'BPMC_BPD_SOAP_UQ' )
CREATE UNIQUE INDEX BPMC_BPD_SOAP_UQ ON BPM_BPD_SOAPHEADER(BPD_INSTANCE_ID)

GO

						
INSERT INTO LSW_LOCK("LOCK_ID", "DESCRIPTION")
    VALUES('LOG_ADD_LOCK_KEY', 
    'Lock required for adding logs to bpm_repository_log 
and updating timestamp in bpm_project_subscription ')
						
GO


ALTER TABLE LSW_USR_GRP_XREF ALTER COLUMN GROUP_NAME NVARCHAR(256) NULL
GO


ALTER TABLE LSW_USR_GRP_XREF ALTER COLUMN DISPLAY_NAME NVARCHAR(256) NULL
GO


GO


ALTER  TABLE LSW_TASK_NARR 
ADD 
NARRATIVE_RAW IMAGE
GO


							UPDATE LSW_SAVED_SEARCHES SET QUERY='<?xml version="1.0" encoding="UTF-8"?><query organization="byTask"  first-sort="" second-sort=""> <constraints /> <results> <column name="taskSubject" column-type="task"/> <column name="taskNarrative" column-type="task"/> <column name="taskDueDate" column-type="task"/> <column name="taskReceivedDate" column-type="task"/> <column name="taskPriority" column-type="task"/> <column name="taskStatus" column-type="task"/> <column name="taskReceivedFrom" column-type="task"/> <column name="taskClosedDate" column-type="task"/> <column name="assignedToUser" column-type="task"/> <column name="assignedToRoleDisplayName" column-type="task"/> <column name="taskActivityName" column-type="task"/> <column name="taskId" column-type="task"/> <column name="taskAtRiskTime" column-type="task"/> <column name="taskIsAtRisk" column-type="task"/> <column name="instanceId" column-type="instance"/> <column name="instanceName" column-type="instance"/> <column name="bpdId" column-type="instance"/> <column name="instanceProcessApp" column-type="instance"/> <column name="instanceSnapshot" column-type="instance"/> <column name="instanceSnapshotId" column-type="instance"/> </results> </query>' WHERE SEARCH_NAME='IBM.DEFAULTALLTASKSLIST_75'
						
GO


GO


							exec sp_rename 'LSW_SYSTEM."KEY"','PROPKEY','COLUMN'
							GO
							exec sp_rename 'LSW_SYSTEM.VALUE','PROPVALUE','COLUMN'
							GO
						
GO


if not exists (select name from sys.indexes where name = 'IDX9_LSW_TASK' )
CREATE INDEX IDX9_LSW_TASK ON LSW_TASK(BPD_INSTANCE_ID,TASK_ID,CREATED_BY_BPD_FLOW_OBJECT_ID,STATUS) 
GO


if not exists (select name from sysobjects where name = 'BPM_TASK_INDEX')
CREATE  TABLE BPM_TASK_INDEX(
TASK_ID DECIMAL(38,0) NOT NULL,
MAJOR_EVENT_DATETIME DATETIME,
MINOR_EVENT_DATETIME DATETIME,
TASK_DATA IMAGE)
GO


if not exists (select name from sysobjects where name = 'BPM_TASK_INDEX_PK' )     
ALTER TABLE BPM_TASK_INDEX ADD CONSTRAINT BPM_TASK_INDEX_PK
    PRIMARY KEY(TASK_ID ) 
GO


if not exists (select name from sysobjects where name = 'BPM_TASK_INDEX_FK' )
ALTER TABLE BPM_TASK_INDEX ADD CONSTRAINT BPM_TASK_INDEX_FK
	FOREIGN KEY(TASK_ID)
	REFERENCES LSW_TASK(TASK_ID)
	ON DELETE CASCADE
GO


if not exists (select name from sys.indexes where name = 'BPM_TASK_INDEX_IDX' )
CREATE INDEX BPM_TASK_INDEX_IDX ON BPM_TASK_INDEX(MAJOR_EVENT_DATETIME,TASK_ID) 
GO


if not exists (select name from sysobjects where name = 'BPM_TASK_INDEX_JOB')
CREATE  TABLE BPM_TASK_INDEX_JOB(
INDEX_ID UNIQUEIDENTIFIER NOT NULL,
INDEX_START_TIME DATETIME NOT NULL,
INDEX_END_TIME DATETIME,
RECORDS_INDEXED DECIMAL(38,0),
RESULT_VALUE NVARCHAR(256))
GO


if not exists (select name from sysobjects where name = 'BPM_TASK_INDEX_JOB_PK' )     
ALTER TABLE BPM_TASK_INDEX_JOB ADD CONSTRAINT BPM_TASK_INDEX_JOB_PK
    PRIMARY KEY(INDEX_ID ,INDEX_START_TIME ) 
GO


if not exists (select name from sys.indexes where name = 'IDX1_BPM_TASK_MARKERS' )
CREATE INDEX IDX1_BPM_TASK_MARKERS ON BPM_TASK_MARKERS(TARGET_USER,MARKER_TYPE) 
GO


if not exists (select name from sys.indexes where name = 'IDX2_BPM_TASK_MARKERS' )
CREATE INDEX IDX2_BPM_TASK_MARKERS ON BPM_TASK_MARKERS(TASK_ID) 
GO


if not exists (select name from sys.indexes where name = 'BPM_IDX3_NODE' )
CREATE INDEX BPM_IDX3_NODE ON BPM_CONTRIBUTION(FILENAME) 
GO


							DROP INDEX LSW_PO_VERSIONS.IDX_PO_VERSIONS
							GO
							
							DROP INDEX LSW_PO_VERSIONS.IDX2_PO_VERSIONS
							GO
							
							DROP INDEX LSW_PO_VERSIONS.IDX3_PO_VERSIONS
							GO
							
							DROP INDEX LSW_PO_VERSIONS.IDX4_PO_VERSIONS
							GO
							
							DROP INDEX LSW_PO_VERSIONS.IDX5_PO_VERSIONS
							GO
							
							DROP INDEX LSW_PO_VERSIONS.IDX6_PO_VERSIONS
							GO
							
							DROP INDEX LSW_PO_VERSIONS.IDX7_PO_VERSIONS
						
GO


GO


if not exists (select name from sys.indexes where name = 'IDX_PO_VERSIONS' )
CREATE INDEX IDX_PO_VERSIONS ON LSW_PO_VERSIONS(PO_TYPE,BRANCH_ID,START_SEQ_NUM,END_SEQ_NUM,PO_VERSION_ID) 
GO


if not exists (select name from sys.indexes where name = 'IDX2_PO_VERSIONS' )
CREATE INDEX IDX2_PO_VERSIONS ON LSW_PO_VERSIONS(BRANCH_ID,END_SEQ_NUM) 
GO


if not exists (select name from sys.indexes where name = 'LSWC_UXREF_UQ2' )
CREATE UNIQUE INDEX LSWC_UXREF_UQ2 ON LSW_USR_XREF(USER_ID,USER_NAME)

GO


if not exists (select name from sys.indexes where name = 'LSWC_TASK_STATUS_INDEX1' )
CREATE INDEX LSWC_TASK_STATUS_INDEX1 ON LSW_TASK_STATUS_CODES(NAME) 
GO


if not exists (select name from sys.indexes where name = 'LSWC_TASK_STATUS_INDEX2' )
CREATE INDEX LSWC_TASK_STATUS_INDEX2 ON LSW_TASK_STATUS_CODES(STATUS_VALUE) 
GO


							DROP INDEX LSW_BPD_INSTANCE.LSWC_SNPSHT_ID_NUQ
						
GO


if not exists (select name from sys.indexes where name = 'INDEX1_LSW_BPD_INST' )
CREATE INDEX INDEX1_LSW_BPD_INST ON LSW_BPD_INSTANCE(SNAPSHOT_ID,BPD_INSTANCE_ID) 
GO


if not exists (select name from sys.indexes where name = 'INDEX2_LSW_BPD_INST' )
CREATE INDEX INDEX2_LSW_BPD_INST ON LSW_BPD_INSTANCE(EXECUTION_STATUS,BPD_INSTANCE_ID) 
GO


if not exists (select name from sys.indexes where name = 'INDEX3_LSW_BPD_INST' )
CREATE INDEX INDEX3_LSW_BPD_INST ON LSW_BPD_INSTANCE(BPD_INSTANCE_ID,EXECUTION_STATUS,CACHED_BPD_VERSION_ID) 
GO


GO


							if exists (SELECT * FROM INFORMATION_SCHEMA.ROUTINES WHERE  ROUTINE_NAME = 'LSW_HOUSE_KEEPING')
								DROP PROCEDURE LSW_HOUSE_KEEPING
							GO
							CREATE PROCEDURE LSW_HOUSE_KEEPING(@modeHK DECIMAL) AS
							DECLARE @rootTaskId DECIMAL
							DECLARE @taskId DECIMAL
							DECLARE @taskStatus VARCHAR(2)
							DECLARE @flgDelete CHAR(1)
							DECLARE @statuses VARCHAR(64)
							DECLARE @sql NVARCHAR(128)
							DECLARE @sqlParams NVARCHAR(128)
							DECLARE @flgStatusNotExist CHAR(1)
							IF (@modeHK = 1)
							BEGIN
								BEGIN TRANSACTION
								DELETE FROM LSW_TASK_FILE WHERE TASK_ID IN (SELECT TASK_ID FROM LSW_TASK WHERE STATUS IN (91,92))
								DELETE FROM LSW_FILE WHERE FILE_ID NOT IN (SELECT FILE_ID FROM LSW_TASK_FILE) OR FILE_ID NOT IN (SELECT FILE_ID FROM LSW_TASK,LSW_TASK_FILE WHERE LSW_TASK.TASK_ID = LSW_TASK_FILE.TASK_ID)
								DELETE FROM LSW_TASK_FILE WHERE FILE_ID NOT IN (SELECT FILE_ID FROM LSW_FILE) OR TASK_ID NOT IN (SELECT LSW_TASK.TASK_ID FROM LSW_TASK,LSW_TASK_FILE WHERE LSW_TASK.TASK_ID = LSW_TASK_FILE.TASK_ID)
								DELETE FROM LSW_USR_GRP_MEM_XREF WHERE GROUP_ID IN (
									SELECT g.GROUP_ID FROM LSW_USR_GRP_XREF g WHERE NOT EXISTS (SELECT 1 FROM LSW_TASK t WHERE g.GROUP_ID = ABS(t.GROUP_ID)) AND g.GROUP_TYPE = 2)
								DELETE FROM LSW_USR_GRP_XREF WHERE GROUP_ID IN (
									SELECT g.GROUP_ID FROM LSW_USR_GRP_XREF g WHERE NOT EXISTS (SELECT 1 FROM LSW_TASK t WHERE g.GROUP_ID = ABS(t.GROUP_ID)) AND g.GROUP_TYPE = 2)
								COMMIT TRANSACTION
							END
							ELSE IF (@modeHK > 1)
							BEGIN
								SET @statuses = ''
								IF (@modeHK >= 2) SET @statuses = '91,92'
								IF (@modeHK >= 3) SET @statuses = @statuses + ',21'
								IF (@modeHK >= 4) SET @statuses = @statuses + ',31,32'
								CREATE TABLE #TEMP_DELETE_TASK (
									TASK_ID DECIMAL(12,0) NOT NULL)
								DECLARE curAllRootTasks CURSOR SCROLL FOR SELECT DISTINCT ORIG_TASK_ID FROM LSW_TASK
								OPEN curAllRootTasks
								WHILE (1 = 1)
								BEGIN
									FETCH curAllRootTasks INTO @rootTaskId
									IF (@@FETCH_STATUS = -1) BREAK;
									EXEC('DECLARE curRootTask CURSOR SCROLL FOR SELECT TASK_ID, STATUS FROM LSW_TASK WHERE ORIG_TASK_ID = ' + @rootTaskId)
									OPEN curRootTask
									SET @flgDelete = 'T'
									WHILE (1 = 1)
									BEGIN
										FETCH curRootTask INTO @taskId,@taskStatus
										IF (@@FETCH_STATUS = -1) BREAK;
										SET @flgStatusNotExist = 'F'
										SET @sql = 'SELECT @pflgStatusNotExist = ''T'' WHERE ' + @taskStatus + ' NOT IN (' + @statuses + ')'
										SET @sqlParams = '@pflgStatusNotExist CHAR OUTPUT'
										EXEC sp_executesql @sql, @sqlParams, @pflgStatusNotExist = @flgStatusNotExist OUTPUT
										IF (@flgStatusNotExist = 'T')
										BEGIN
											SET @flgDelete = 'F'
											BREAK
										END
										INSERT INTO #TEMP_DELETE_TASK VALUES (@taskId)
									END
									CLOSE curRootTask
									DEALLOCATE curRootTask
									IF (@flgDelete = 'T')
									BEGIN
										DECLARE curDeleteTask CURSOR SCROLL FOR SELECT TASK_ID FROM #TEMP_DELETE_TASK
										OPEN curDeleteTask
										WHILE (1 = 1)
										BEGIN
											FETCH curDeleteTask INTO @taskId
											IF (@@FETCH_STATUS = -1) BREAK;
											BEGIN TRANSACTION
											DELETE FROM LSW_TASK_NARR WHERE TASK_ID = @taskId
											DELETE FROM LSW_TASK_FILE WHERE TASK_ID = @taskId
											DELETE FROM LSW_TASK_ADDR WHERE TASK_ID = @taskId
											DELETE FROM LSW_TASK_EXECUTION_CONTEXT WHERE TASK_ID = @taskId
											DELETE FROM LSW_TASK_IPF_DATA WHERE TASK_ID = @taskId
											DELETE FROM LSW_TASK_EXTACT_DATA WHERE TASK_ID = @taskId
											DELETE FROM LSW_TASK WHERE TASK_ID = @taskId
											COMMIT TRANSACTION
										END
										CLOSE curDeleteTask
										DEALLOCATE curDeleteTask
									END
									DELETE FROM #TEMP_DELETE_TASK
								END
								CLOSE curAllRootTasks
								DEALLOCATE curAllRootTasks
								DROP TABLE #TEMP_DELETE_TASK
								DELETE FROM LSW_FILE WHERE FILE_ID NOT IN (SELECT FILE_ID FROM LSW_TASK_FILE)
								DELETE FROM LSW_USR_GRP_MEM_XREF WHERE GROUP_ID IN (
									SELECT g.GROUP_ID FROM LSW_USR_GRP_XREF g WHERE NOT EXISTS (SELECT 1 FROM LSW_TASK t WHERE g.GROUP_ID = ABS(t.GROUP_ID)) AND g.GROUP_TYPE = 2)
								DELETE FROM LSW_USR_GRP_XREF WHERE GROUP_ID IN (
									SELECT g.GROUP_ID FROM LSW_USR_GRP_XREF g WHERE NOT EXISTS (SELECT 1 FROM LSW_TASK t WHERE g.GROUP_ID = ABS(t.GROUP_ID)) AND g.GROUP_TYPE = 2)
							END
							GO
						
GO


							BEGIN TRANSACTION;
							INSERT INTO LSW_PROJECT (PROJECT_ID, CREATED_BY_USER_ID, CREATED_ON, LAST_MODIFIED, LAST_MODIFIED_BY_USER_ID, NAME, DESCRIPTION, SHORT_NAME, IS_TOOLKIT, IS_BRANCHING_ENABLED, IS_HIDDEN)
   							VALUES ('dbecd816-afed-47b0-ba92-c13256fcb566', 1, '01/01/1969 17:00:00', '01/01/1969 17:00:00', 1, 'System Governance', 'IBM BPM Governance Data and Services', 'TWSYSG', 'T', 'F', 'F');
   							INSERT INTO LSW_BRANCH(BRANCH_ID, CREATED_BY_USER_ID, CREATED_ON, LAST_MODIFIED, LAST_MODIFIED_BY_USER_ID, NAME, ACRONYM, DESCRIPTION, TIP_SNAPSHOT_ID, TIP_SEQ_NUM, PROJECT_ID, IS_DEFAULT)
							VALUES ('f757be35-ebca-4e58-a85c-6b34f3c15149', 1, '01/01/1969 17:00:00', '01/01/1969 17:00:00', 1, 'Main', 'Main', 'The main branch of the TWSYSG project', '8b0bdb20-6dd1-4357-945a-4cdf0cbd020d', 256, 'dbecd816-afed-47b0-ba92-c13256fcb566', 'T');
							COMMIT TRANSACTION;
						
GO


							BEGIN TRANSACTION;
							INSERT INTO LSW_ACL_ENTRY (ACL_ENTRY_ID,GROUP_ID,PO_TYPE,PO_ID,MASK)
							VALUES(7, 3, 2066, 'dbecd816-afed-47b0-ba92-c13256fcb566', 127);
							INSERT INTO LSW_ACL_ENTRY (ACL_ENTRY_ID,GROUP_ID,PO_TYPE,PO_ID,MASK)
							VALUES(8, 3, 2066, 'b691179d-e7a4-4a27-b89b-f2263d0280e7', 63);
							INSERT INTO LSW_ACL_ENTRY (ACL_ENTRY_ID,GROUP_ID,PO_TYPE,PO_ID,MASK)
							VALUES(9, 4, 2066, 'b691179d-e7a4-4a27-b89b-f2263d0280e7', 63);
							INSERT INTO LSW_ACL_ENTRY (ACL_ENTRY_ID,GROUP_ID,PO_TYPE,PO_ID,MASK)
							VALUES(10, 3, 2066, '4b3882d9-e886-4f08-9d0c-078ebda719b9', 63);
							INSERT INTO LSW_ACL_ENTRY (ACL_ENTRY_ID,GROUP_ID,PO_TYPE,PO_ID,MASK)
							VALUES(11, 4, 2066, '4b3882d9-e886-4f08-9d0c-078ebda719b9', 63);
							COMMIT TRANSACTION;
						
GO


							BEGIN TRANSACTION;
							INSERT INTO LSW_PROJECT (PROJECT_ID, CREATED_BY_USER_ID, CREATED_ON, LAST_MODIFIED, LAST_MODIFIED_BY_USER_ID, NAME, DESCRIPTION, SHORT_NAME, IS_TOOLKIT, IS_BRANCHING_ENABLED, IS_HIDDEN)
   							VALUES ('4b3882d9-e886-4f08-9d0c-078ebda719b9', 1, '01/01/1969 17:00:00', '01/01/1969 17:00:00', 1, 'Content Management', 'IBM BPM Content Management Data, Services and Coach views.', 'SYSCM', 'T', 'F', 'F');
   							INSERT INTO LSW_BRANCH(BRANCH_ID, CREATED_BY_USER_ID, CREATED_ON, LAST_MODIFIED, LAST_MODIFIED_BY_USER_ID, NAME, ACRONYM, DESCRIPTION, TIP_SNAPSHOT_ID, TIP_SEQ_NUM, PROJECT_ID, IS_DEFAULT)
							VALUES ('4961c615-3524-4196-90da-93c49d237009', 1, '01/01/1969 17:00:00', '01/01/1969 17:00:00', 1, 'Main', 'Main', 'The main branch of the SYSCM project', '29dbc7ff-aace-481a-ba72-be56c0180448', 256, '4b3882d9-e886-4f08-9d0c-078ebda719b9', 'T');
							COMMIT TRANSACTION;
						
GO


							BEGIN TRANSACTION;
							INSERT INTO LSW_PROJECT (PROJECT_ID, CREATED_BY_USER_ID, CREATED_ON, LAST_MODIFIED, LAST_MODIFIED_BY_USER_ID, NAME, DESCRIPTION, SHORT_NAME, IS_TOOLKIT, IS_BRANCHING_ENABLED, IS_HIDDEN)
   							VALUES ('b691179d-e7a4-4a27-b89b-f2263d0280e7', 1, '01/01/1969 17:00:00', '01/01/1969 17:00:00', 1, 'Coaches', 'IBM BPM System Coaches', 'SYSC', 'T', 'F', 'F');
   							INSERT INTO LSW_BRANCH(BRANCH_ID, CREATED_BY_USER_ID, CREATED_ON, LAST_MODIFIED, LAST_MODIFIED_BY_USER_ID, NAME, ACRONYM, DESCRIPTION, TIP_SNAPSHOT_ID, TIP_SEQ_NUM, PROJECT_ID, IS_DEFAULT)
							VALUES ('50f91713-f1c4-4859-897f-89720db5dc3e', 1, '01/01/1969 17:00:00', '01/01/1969 17:00:00', 1, 'Main', 'Main', 'The main branch of the SYSC project', 'b10f8fa8-75a6-47e4-899c-b5e876169c68', 256, 'b691179d-e7a4-4a27-b89b-f2263d0280e7', 'T');
							COMMIT TRANSACTION;
						
GO


							BEGIN TRANSACTION;
							INSERT INTO LSW_ENV_VAR_TYPE (ENV_VAR_TYPE_ID,NAME,DESCRIPTION)
							VALUES(6, 6, 'ECM Server');
							COMMIT TRANSACTION;
						
GO


		
/* END of phase ProcUpgradeTo800 */

	
/*
 * MSSQL Upgrade Script for TeamWorks
 * From Version: BPM 8.0.0
 * To Version: BPM 8.0.1
 */

    

		
/* START of phase ProcUpgradeTo801 */
    
			
ALTER  TABLE LSW_UCA 
ADD 
UCA_EVENT_TYPE_REF DECIMAL(2, 0)
GO


ALTER  TABLE LSW_UCA 
ADD 
VARIABLE_REF UNIQUEIDENTIFIER
GO


ALTER  TABLE LSW_UCA 
ADD 
IMPLEMENTATION_TYPE NVARCHAR(80)
GO


if not exists (select name from sysobjects where name = 'BPM_UCA_EVENT_TYPE')
CREATE  TABLE BPM_UCA_EVENT_TYPE(
UCA_EVENT_TYPE_ID DECIMAL(2, 0) NOT NULL,
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT)
GO


if not exists (select name from sysobjects where name = 'LSWC_UCA_EVENT_TYPE_PK' )     
ALTER TABLE BPM_UCA_EVENT_TYPE ADD CONSTRAINT LSWC_UCA_EVENT_TYPE_PK
    PRIMARY KEY(UCA_EVENT_TYPE_ID ) 
GO


							BEGIN TRANSACTION;
							INSERT INTO BPM_UCA_EVENT_TYPE (UCA_EVENT_TYPE_ID,NAME,DESCRIPTION)
							VALUES(0, 0, 'Timer');
							INSERT INTO BPM_UCA_EVENT_TYPE (UCA_EVENT_TYPE_ID,NAME,DESCRIPTION)
							VALUES(1, 1, 'Message');							
							INSERT INTO BPM_UCA_EVENT_TYPE (UCA_EVENT_TYPE_ID,NAME,DESCRIPTION)
							VALUES(2, 2, 'Content');							
							COMMIT TRANSACTION;
						
GO


ALTER  TABLE LSW_MANAGED_ASSET 
ADD 
IS_DOCUMENTATION_FILE NCHAR(1) DEFAULT 'F' NOT NULL
GO


INSERT INTO LSW_ENV_VAR_TYPE (ENV_VAR_TYPE_ID,NAME,DESCRIPTION)
    VALUES(8, '8', 'Connections Server')
                        
GO


ALTER  TABLE BPM_COACHNG_BOUNDARY_EVENT 
ADD 
IS_VALIDATE_BOUNDARY_EVENT NCHAR(1) DEFAULT 'F'
GO


ALTER  TABLE BPM_COACHNG_BOUNDARY_EVENT 
ADD 
FIRE_VALIDATION DECIMAL(1, 0) DEFAULT 0
GO


if not exists (select name from sysobjects where name = 'BPM_GOVERNANCE_EVENT')
CREATE  TABLE BPM_GOVERNANCE_EVENT(
EVENT_TYPE_ID UNIQUEIDENTIFIER NOT NULL,
EVENT_TYPE DECIMAL(8, 0) NOT NULL,
EVENT_TYPE_NAME NVARCHAR(198) NOT NULL,
GOV_DEFAULT_SNAPSHOT_ID UNIQUEIDENTIFIER NOT NULL,
GOV_DEFAULT_PROCESS_ID UNIQUEIDENTIFIER NOT NULL,
GOV_DEFAULT_PROCESS_TYPE DECIMAL(8, 0) NOT NULL)
GO


if not exists (select name from sysobjects where name = 'BPM_GOVERNANCE_ASSIGNMENT')
CREATE  TABLE BPM_GOVERNANCE_ASSIGNMENT(
ASSIGNMENT_ID UNIQUEIDENTIFIER NOT NULL,
PROJECT_ID UNIQUEIDENTIFIER NOT NULL,
EVENT_TYPE_ID UNIQUEIDENTIFIER NOT NULL,
GOV_SNAPSHOT_ID UNIQUEIDENTIFIER NOT NULL,
GOV_PROCESS_ID UNIQUEIDENTIFIER NOT NULL,
GOV_PROCESS_TYPE DECIMAL(8, 0) NOT NULL,
ACTIVE NCHAR(1) DEFAULT 'T' NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
GO


if not exists (select name from sysobjects where name = 'BPM_GOV_DEFAULTS_PK' )     
ALTER TABLE BPM_GOVERNANCE_EVENT ADD CONSTRAINT BPM_GOV_DEFAULTS_PK
    PRIMARY KEY(EVENT_TYPE_ID ) 
GO


if not exists (select name from sysobjects where name = 'BPM_GOVERNANCE_ASSIGNMENT_PK' )     
ALTER TABLE BPM_GOVERNANCE_ASSIGNMENT ADD CONSTRAINT BPM_GOVERNANCE_ASSIGNMENT_PK
    PRIMARY KEY(ASSIGNMENT_ID ) 
GO


if not exists (select name from sysobjects where name = 'BPM_GOVERNANCE_ASSIGNMENT_FK1' )
ALTER TABLE BPM_GOVERNANCE_ASSIGNMENT ADD CONSTRAINT BPM_GOVERNANCE_ASSIGNMENT_FK1
	FOREIGN KEY(PROJECT_ID)
	REFERENCES LSW_PROJECT(PROJECT_ID)
	ON DELETE CASCADE
GO


							BEGIN TRANSACTION;
								INSERT INTO BPM_GOVERNANCE_EVENT(EVENT_TYPE_ID, EVENT_TYPE, EVENT_TYPE_NAME, GOV_DEFAULT_SNAPSHOT_ID, GOV_DEFAULT_PROCESS_ID, GOV_DEFAULT_PROCESS_TYPE) VALUES('dbecd816-afed-47b0-ba92-c13256fcb568', 0, 'Installation Requested', '8b0bdb20-6dd1-4357-945a-4cdf0cbd020d', 'b0d87b96-5044-4390-b0f5-4ba05d63bc28', 25);
								INSERT INTO BPM_GOVERNANCE_EVENT(EVENT_TYPE_ID, EVENT_TYPE, EVENT_TYPE_NAME, GOV_DEFAULT_SNAPSHOT_ID, GOV_DEFAULT_PROCESS_ID, GOV_DEFAULT_PROCESS_TYPE) VALUES('dbecd816-afed-47b0-ba92-c13256fcb569', 1, 'Snapshot Status Change', '8b0bdb20-6dd1-4357-945a-4cdf0cbd020d', '291536f1-aa21-4650-8ac9-c62eaa3fa110', 25);
							COMMIT TRANSACTION;
						
GO


DROP TABLE LSW_ORG_CHART
GO


if not exists (select name from sysobjects where name = 'BPM_EVENT_SUBSCRIPTION')
CREATE  TABLE BPM_EVENT_SUBSCRIPTION(
EVENT_SUBSCRIPTION_ID UNIQUEIDENTIFIER NOT NULL,
EVENT_SUBSCRIPTION_TYPE_ID DECIMAL(2, 0) NOT NULL,
SERVER_NAME NVARCHAR(256),
EVENT_CLASS NVARCHAR(256),
OBJECT_TYPE_ID NVARCHAR(256),
OBJECT_TYPE_ID_DISPLAY_NAME NVARCHAR(256),
EVENT_TYPE NVARCHAR(256),
INCLUDE_SUB_TYPE NCHAR(1) DEFAULT 'F',
PROCESS_REF UNIQUEIDENTIFIER,
PARTICIPANT_REF UNIQUEIDENTIFIER,
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
GO


if not exists (select name from sysobjects where name = 'BPM_EVENT_SUBSCRIPTION_TYPE')
CREATE  TABLE BPM_EVENT_SUBSCRIPTION_TYPE(
EVENT_SUBSCRIPTION_TYPE_ID DECIMAL(2, 0) NOT NULL,
NAME NVARCHAR(64) NOT NULL,
DESCRIPTION NTEXT)
GO


if not exists (select name from sysobjects where name = 'BPM_EVENT_SUBSCRIPTION_PK' )     
ALTER TABLE BPM_EVENT_SUBSCRIPTION ADD CONSTRAINT BPM_EVENT_SUBSCRIPTION_PK
    PRIMARY KEY(VERSION_ID ) 
GO


if not exists (select name from sysobjects where name = 'LSWC_BPM_EVT_SUBN_TYPE_PK' )     
ALTER TABLE BPM_EVENT_SUBSCRIPTION_TYPE ADD CONSTRAINT LSWC_BPM_EVT_SUBN_TYPE_PK
    PRIMARY KEY(EVENT_SUBSCRIPTION_TYPE_ID ) 
GO


if not exists (select name from sys.indexes where name = 'BPM_EVENT_SUBSCRIPTION_PK3' )
CREATE INDEX BPM_EVENT_SUBSCRIPTION_PK3 ON BPM_EVENT_SUBSCRIPTION(GUID) 
GO


if not exists (select name from sys.indexes where name = 'BPM_EVENT_SUBSCRIPTION_IDX1' )
CREATE INDEX BPM_EVENT_SUBSCRIPTION_IDX1 ON BPM_EVENT_SUBSCRIPTION(EVENT_SUBSCRIPTION_TYPE_ID,EVENT_TYPE,OBJECT_TYPE_ID,INCLUDE_SUB_TYPE) 
GO


							BEGIN TRANSACTION;
							INSERT INTO BPM_EVENT_SUBSCRIPTION_TYPE (EVENT_SUBSCRIPTION_TYPE_ID,NAME,DESCRIPTION)
							VALUES(0, 0, 'ECM');
							COMMIT TRANSACTION;
						
GO


if not exists (select name from sysobjects where name = 'LSW_STAY_ON_PAGE')
CREATE  TABLE LSW_STAY_ON_PAGE(
STAY_ON_PAGE_ID UNIQUEIDENTIFIER NOT NULL,
GUID NVARCHAR(128) NOT NULL,
VERSION_ID UNIQUEIDENTIFIER NOT NULL,
LAST_MODIFIED DATETIME NOT NULL,
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) NOT NULL)
GO


if not exists (select name from sysobjects where name = 'BPM_STAY_ON_PAGE_PK' )     
ALTER TABLE LSW_STAY_ON_PAGE ADD CONSTRAINT BPM_STAY_ON_PAGE_PK
    PRIMARY KEY(VERSION_ID ) 
GO


if not exists (select name from sys.indexes where name = 'BPM_STAY_ON_PAGE_PK3' )
CREATE INDEX BPM_STAY_ON_PAGE_PK3 ON LSW_STAY_ON_PAGE(GUID) 
GO


ALTER  TABLE LSW_BPD 
ADD 
TEMPLATE_ID UNIQUEIDENTIFIER
GO


ALTER  TABLE LSW_BPD_PARAMETER 
ADD 
IS_READ_ONLY NCHAR(1) DEFAULT 'F'
GO


ALTER  TABLE BPM_COACH_VIEW 
ADD 
VALIDATE_JS_FUNCTION NTEXT
GO


ALTER  TABLE LSW_FAVORITE 
ADD 
CACHED_EVENT_SUB_VERSION_ID UNIQUEIDENTIFIER
GO


ALTER  TABLE LSW_FAVORITE 
ADD 
EVENT_SOURCE_ID NVARCHAR(128)
GO


							BEGIN TRANSACTION;
							INSERT INTO LSW_ACL_ENTRY (ACL_ENTRY_ID,GROUP_ID,PO_TYPE,PO_ID,MASK)
							VALUES(12, 4, 2066, 'dbecd816-afed-47b0-ba92-c13256fcb566', 5);
							COMMIT TRANSACTION;
						
GO


ALTER  TABLE BPM_COACH_VIEW 
ADD 
USE_URL_BINDING NCHAR(1) DEFAULT 'F'
GO


ALTER  TABLE LSW_BLUEPRINT_SUBSCRIPTION 
ADD 
LAST_MODIFIED DATETIME DEFAULT CURRENT_TIMESTAMP NOT NULL
GO


GO


ALTER  TABLE LSW_BLUEPRINT_SUBSCRIPTION 
ADD 
LAST_MODIFIED_BY_USER_ID DECIMAL(38,0) DEFAULT 1 NOT NULL
GO


ALTER  TABLE LSW_WEB_SERVICE 
ADD 
TARGET_NAMESPACE NVARCHAR(512)
GO


ALTER  TABLE LSW_WEB_SERVICE 
ADD 
TARGET_NAMESPACE_SCHEME NVARCHAR(64)
GO


ALTER  TABLE LSW_SNAPSHOT 
ADD 
TIP_DEPLOYMENT_IN_PROGRESS NCHAR(1) DEFAULT 'F'
GO


ALTER  TABLE BPM_TASK_INDEX_JOB 
ADD 
INDEX_LAST_PURGE_TIME DATETIME
GO


ALTER  TABLE BPM_COACH_VIEW_CONFIG_OPTION 
ADD 
GROUP_NAME NVARCHAR(64)
GO


							BEGIN TRANSACTION;
							INSERT INTO LSW_SNAPSHOT (SNAPSHOT_ID, CREATED_BY_USER_ID, CREATED_ON, ACRONYM, BRANCH_ID, PROJECT_ID, SEQ_NUM, ORIG_CREATED_ON, LAST_MODIFIED, LAST_MODIFIED_BY_USER_ID)
   							VALUES ('29dbc7ff-aace-481a-ba72-be56c0180448', 1, '01/01/1969 17:00:00', '29dbc7ff-aace-481a-ba72-be56c0180448', '4961c615-3524-4196-90da-93c49d237009', '4b3882d9-e886-4f08-9d0c-078ebda719b9', 256, '01/01/1969 17:00:00', '01/01/1969 17:00:00', 1);
							COMMIT TRANSACTION;
						
GO


if not exists (select name from sys.indexes where name = 'BPM_SHARED_OBJECT_IDX1' )
CREATE INDEX BPM_SHARED_OBJECT_IDX1 ON BPM_SHARED_OBJECT(TASK_ID) 
GO


							BEGIN TRANSACTION;
							INSERT INTO LSW_SNAPSHOT (SNAPSHOT_ID, CREATED_BY_USER_ID, CREATED_ON, ACRONYM, BRANCH_ID, PROJECT_ID, SEQ_NUM, ORIG_CREATED_ON, LAST_MODIFIED, LAST_MODIFIED_BY_USER_ID)
   							VALUES ('e01d46a5-6dc9-4545-9940-7e843777321d', 1, '01/01/1969 17:00:00', 'e01d46a5-6dc9-4545-9940-7e843777321d', '50f91713-f1c4-4859-897f-89720db5dc3e', 'b691179d-e7a4-4a27-b89b-f2263d0280e7', 256, '01/01/1969 17:00:00', '01/01/1969 17:00:00', 1);
   							UPDATE LSW_BRANCH SET TIP_SNAPSHOT_ID='e01d46a5-6dc9-4545-9940-7e843777321d' WHERE BRANCH_ID='50f91713-f1c4-4859-897f-89720db5dc3e';
							COMMIT TRANSACTION;
						
GO


if not exists (select name from sys.indexes where name = 'IDX6_SNAPSHOT' )
CREATE INDEX IDX6_SNAPSHOT ON LSW_SNAPSHOT(BRANCH_ID,IS_ARCHIVED,CREATED_ON) 
GO


ALTER  TABLE BPM_TASK_INDEX 
ADD 
DELETED_DATETIME DATETIME
GO


ALTER TABLE BPM_TASK_INDEX DROP CONSTRAINT BPM_TASK_INDEX_FK
                        
GO


GO


if not exists (select name from sys.indexes where name = 'IDX10_LSW_TASK' )
CREATE INDEX IDX10_LSW_TASK ON LSW_TASK(BPD_INSTANCE_ID,STATUS) 
GO


          
/* END of phase ProcUpgradeTo801 */

      
/*
 * MSSQL Upgrade Script for TeamWorks
 * From Version: BPM 8.0.1.1
 * To Version: BPM 8.0.1.2
 */

    

          
/* START of phase ProcUpgradeTo8012 */
    
             
GO


if exists (SELECT * FROM INFORMATION_SCHEMA.ROUTINES WHERE  ROUTINE_NAME = 'LSW_ERASE_TEMP_GROUPS')
    DROP PROCEDURE LSW_ERASE_TEMP_GROUPS
GO
CREATE PROCEDURE LSW_ERASE_TEMP_GROUPS AS

  BEGIN

    DECLARE @groupId DECIMAL

    DECLARE groupsToDelete SCROLL CURSOR FOR
      SELECT DISTINCT g.GROUP_ID 
      FROM LSW_USR_GRP_XREF g 
      WHERE NOT EXISTS (SELECT 1 FROM LSW_TASK t WHERE g.GROUP_ID = ABS(t.GROUP_ID)) 
      AND g.GROUP_TYPE = 2
      FOR READ ONLY

    BEGIN TRANSACTION

      OPEN groupsToDelete

      FETCH groupsToDelete INTO @groupId

      WHILE @@FETCH_STATUS = 0
        BEGIN
          
          DELETE FROM LSW_USR_GRP_MEM_XREF WHERE GROUP_ID = @groupId
          DELETE FROM LSW_USR_GRP_XREF WHERE GROUP_ID = @groupId
          
          FETCH groupsToDelete INTO @groupId
          
        END

      CLOSE groupsToDelete

      DEALLOCATE groupsToDelete

    COMMIT

  END
GO

if exists (SELECT * FROM INFORMATION_SCHEMA.ROUTINES WHERE  ROUTINE_NAME = 'LSW_ERASE_BPD_INST_NO_GROUP')
    DROP PROCEDURE LSW_ERASE_BPD_INST_NO_GROUP
GO
CREATE PROCEDURE LSW_ERASE_BPD_INST_NO_GROUP @bpdInstanceId DECIMAL AS

  BEGIN
  
    DELETE FROM LSW_BPD_INSTANCE_DOC_PROPS WHERE DOC_ID IN (SELECT DOC_ID FROM LSW_BPD_INSTANCE_DOCUMENTS WHERE BPD_INSTANCE_ID = @bpdInstanceId)

    DELETE FROM LSW_BPD_INSTANCE_DOCUMENTS WHERE BPD_INSTANCE_ID = @bpdInstanceId

    DELETE FROM LSW_BPD_INSTANCE_VARIABLES WHERE BPD_INSTANCE_ID = @bpdInstanceId

    DELETE FROM LSW_BPD_INSTANCE_DATA WHERE BPD_INSTANCE_ID = @bpdInstanceId

    DELETE FROM LSW_BPD_NOTIFICATION WHERE BPD_INSTANCE_ID = @bpdInstanceId

    DELETE FROM LSW_RUNTIME_ERROR WHERE BPD_INSTANCE_ID = @bpdInstanceId

    DELETE FROM LSW_BPD_INSTANCE WHERE BPD_INSTANCE_ID = @bpdInstanceId

    DELETE FROM LSW_INST_MSG_INCL WHERE BPD_INSTANCE_ID = @bpdInstanceId 

    DELETE FROM LSW_INST_MSG_EXCL WHERE BPD_INSTANCE_ID = @bpdInstanceId

  END

GO

if exists (SELECT * FROM INFORMATION_SCHEMA.ROUTINES WHERE  ROUTINE_NAME = 'LSW_ERASE_BPD_INSTANCE')
    DROP PROCEDURE LSW_ERASE_BPD_INSTANCE
GO
CREATE PROCEDURE LSW_ERASE_BPD_INSTANCE @bpdInstanceId DECIMAL AS

  BEGIN
  
    EXECUTE LSW_ERASE_BPD_INST_NO_GROUP @bpdInstanceId

    EXECUTE LSW_ERASE_TEMP_GROUPS

  END

GO

if exists (SELECT * FROM INFORMATION_SCHEMA.ROUTINES WHERE  ROUTINE_NAME = 'LSW_ERASE_TASK_NO_GROUP')
    DROP PROCEDURE LSW_ERASE_TASK_NO_GROUP
GO
CREATE PROCEDURE LSW_ERASE_TASK_NO_GROUP @taskId DECIMAL AS

  BEGIN

    DELETE FROM LSW_TASK_ADDR WHERE TASK_ID = @taskId

    DELETE FROM LSW_TASK_EXECUTION_CONTEXT WHERE TASK_ID = @taskId

    DELETE FROM LSW_TASK_NARR WHERE TASK_ID = @taskId

    DELETE FROM LSW_TASK_FILE WHERE TASK_ID = @taskId

    DELETE FROM LSW_TASK_IPF_DATA WHERE TASK_ID = @taskId
    
    DELETE FROM LSW_TASK_EXTACT_DATA WHERE TASK_ID = @taskId
    
    DELETE FROM LSW_TASK WHERE TASK_ID = @taskId
    
  END

GO

if exists (SELECT * FROM INFORMATION_SCHEMA.ROUTINES WHERE  ROUTINE_NAME = 'LSW_ERASE_TASK')
    DROP PROCEDURE LSW_ERASE_TASK
GO
CREATE PROCEDURE LSW_ERASE_TASK @taskId DECIMAL AS

  BEGIN

    EXECUTE LSW_ERASE_TASK_NO_GROUP @taskId

    EXECUTE LSW_ERASE_TEMP_GROUPS
    
  END

GO

if exists (SELECT * FROM INFORMATION_SCHEMA.ROUTINES WHERE  ROUTINE_NAME = 'LSW_BPD_INST_DELETE_NO_GROUP')
    DROP PROCEDURE LSW_BPD_INST_DELETE_NO_GROUP
GO
CREATE PROCEDURE LSW_BPD_INST_DELETE_NO_GROUP @bpdInstanceId DECIMAL AS

  BEGIN

    DECLARE @taskId DECIMAL

    DECLARE tasksToDelete SCROLL CURSOR FOR
      SELECT TASK_ID
      FROM LSW_TASK
      WHERE BPD_INSTANCE_ID = @bpdInstanceId
      FOR READ ONLY

    BEGIN TRANSACTION

      OPEN tasksToDelete

      FETCH tasksToDelete INTO @taskId

      WHILE @@FETCH_STATUS = 0
        BEGIN
          EXECUTE LSW_ERASE_TASK_NO_GROUP @taskId
          FETCH tasksToDelete INTO @taskId
        END

      CLOSE tasksToDelete

      DEALLOCATE tasksToDelete

      EXECUTE LSW_ERASE_BPD_INST_NO_GROUP @bpdInstanceId

    COMMIT

  END
GO

if exists (SELECT * FROM INFORMATION_SCHEMA.ROUTINES WHERE  ROUTINE_NAME = 'LSW_BPD_INSTANCE_DELETE')
    DROP PROCEDURE LSW_BPD_INSTANCE_DELETE
GO
CREATE PROCEDURE LSW_BPD_INSTANCE_DELETE @bpdInstanceId DECIMAL AS

  BEGIN
  
    EXECUTE LSW_BPD_INST_DELETE_NO_GROUP @bpdInstanceId
    
    EXECUTE LSW_ERASE_TEMP_GROUPS

  END
                        
GO


		
/* END of phase ProcUpgradeTo8012 */

	